/* *******************************************************************
 * Copyright 1988-2008 iAnywhere Solutions, Inc.  All rights reserved.
 * *******************************************************************/

#ifndef _SQLERR_H_INCLUDED
#define _SQLERR_H_INCLUDED
#define II_SQLERR

/**************************/
/* sql error return codes */
/**************************/

#define SQLE_GENERIC_ERROR          SQLE_ERROR

#define SQLE_ROLLBACK_RANGE_LOW     -320L
#define SQLE_ROLLBACK_RANGE_HIGH    SQLE_ERROR

#define _SQL_cause_rollback( stat )     \
                  ((stat) >= SQLE_ROLLBACK_RANGE_LOW && \
                   (stat) <= SQLE_ROLLBACK_RANGE_HIGH)
#define _SQL_is_fatal_error( stat )     (  (stat) == SQLE_ERROR  \
                                        || (stat) == SQLE_ACCESS_BEYOND_END_OF_MAX_DBSPACE \
                                        || (stat) == SQLE_CANNOT_ACCESS_FILE \
                                        || (stat) == SQLE_DATABASE_ERROR \
                                        || (stat) == SQLE_DBSPACE_FULL \
                                        || (stat) == SQLE_DEVICE_ERROR \
                                        || (stat) == SQLE_DEVICE_FULL \
                                        || (stat) == SQLE_DYNAMIC_MEMORY_EXHAUSTED \
                                        || (stat) == SQLE_ERROR_WRITING_LOG \
                                        || (stat) == SQLE_LOG_CORRUPTED \
					)
					
/*      Subtransaction Errors */

#define SQLE_SUBTRANS_NOTFOUND                      -220L
#define SQLE_SUBTRANS_REQUIRE_UNDO                  -213L



#define SQLE_NOERROR                                0L
#define SQLE_NOTFOUND                               100L
#define SQLE_TRUNCATED                              101L
#define SQLE_TEMPORARY_TABLE                        102L
#define SQLE_CANNOT_CONVERT                         103L
#define SQLE_ROW_DROPPED_DURING_SCHEMA_UPGRADE      130L
#define SQLE_CANNOT_CONVERT_LOAD_TABLE              124L
#define SQLE_ROW_UPDATED_WARNING                    104L
#define SQLE_PROCEDURE_COMPLETE                     105L
#define SQLE_COLUMN_VALUE_CHANGED                   106L
#define SQLE_CANNOT_EXECUTE_STMT                    111L
#define SQLE_WARNING                                200L
#define SQLE_UNABLE_TO_START_ENGINE                 -80L
#define SQLE_UNABLE_TO_START_ENGINE_FATAL_ERROR     -1033L
#define SQLE_INVALID_COMMAND_LINE                   -81L
#define SQLE_DATABASE_NOT_ACTIVE                    -74L
#define SQLE_START_STOP_DATABASE_DENIED             -75L
#define SQLE_REQUEST_DENIED_NO_DATABASES            -76L
#define SQLE_ALIAS_CLASH                            -77L
#define SQLE_INVALID_LOCAL_OPTION                   -79L
#define SQLE_UNABLE_TO_START_DATABASE               -82L
#define SQLE_UNABLE_TO_START_DATABASE_VER_NEWER     -934L
#define SQLE_UNABLE_TO_START_DATABASE_LOG_ERROR     -935L
#define SQLE_DATABASE_NOT_FOUND                     -83L
#define SQLE_FILE_IN_USE                            -816L
#define SQLE_INVALID_DATABASE                       -84L
#define SQLE_DECRYPT_ERROR                          -851L
#define SQLE_ENCRYPT_ERROR                          -895L
#define SQLE_NO_DATABASE_FILE                       -72L
#define SQLE_COMMUNICATIONS_ERROR                   -85L
#define SQLE_DYNAMIC_MEMORY_EXHAUSTED               -78L
#define SQLE_CLIENT_OUT_OF_MEMORY                   -876L
#define SQLE_NO_MEMORY                              -86L
#define SQLE_DATABASE_NAME_REQUIRED                 -87L
#define SQLE_PROTOCOL_MISMATCH                      -88L
#define SQLE_TLS_HANDSHAKE_FAILED                   -829L
#define SQLE_TLS_INIT_FAILED_ON_SRV                 -838L
#define SQLE_ENGINE_ALREADY_RUNNING                 -96L
#define SQLE_ENGINE_NOT_MULTIUSER                   -89L
#define SQLE_ARGUMENT_CANNOT_BE_NULL                -90L
#define SQLE_INVALID_PARSE_PARAMETER                -95L
#define SQLE_INVALID_DSN_NAME                       -754L
#define SQLE_INVALID_PARAMETER                      -735L
#define SQLE_PAGE_SIZE_TOO_BIG                      -97L
#define SQLE_PAGE_SIZE_TOO_SMALL                    -972L
#define SQLE_PAGE_SIZE_INVALID                      -644L
#define SQLE_DATABASE_NOT_CREATED                   -645L
#define SQLE_AUTHENTICATION_VIOLATION               -98L
#define SQLE_AUTHENTICATION_FAILED                  -218L
#define SQLE_CONNECTIONS_DISABLED                   -99L
#define SQLE_ENGINE_NOT_RUNNING                     -100L
#define SQLE_NOT_CONNECTED                          -101L
#define SQLE_TOO_MANY_CONNECTIONS                   -102L
#define SQLE_INVALID_LOGON                          -103L
#define SQLE_INVALID_MODULE_LOGON                   -104L
#define SQLE_PASSWORD_TOO_SHORT                     -738L
#define SQLE_UNABLE_TO_CONNECT                      -105L
#define SQLE_UNABLE_TO_CONNECT_OR_START             -764L
#define SQLE_CANNOT_OPEN_LOG                        -106L
#define SQLE_ERROR_WRITING_LOG                      -107L
#define SQLE_CONNECTION_NOT_FOUND                   -108L
#define SQLE_STILL_ACTIVE_CONNECTIONS               -109L
#define SQLE_NAME_NOT_UNIQUE                        -110L
#define SQLE_INDEX_NAME_NOT_UNIQUE                  -111L
#define SQLE_EXISTING_PRIMARY_KEY                   -112L
#define SQLE_INVALID_FOREIGN_KEY_DEF                -113L
#define SQLE_INVALID_FOREIGN_KEY_ACTION             -849L
#define SQLE_INVALID_FOREIGN_KEY_TABLE              -850L
#define SQLE_INVALID_FOREIGN_KEY_INDEX              -865L
#define SQLE_VIEW_DEFINITION_ERROR                  -114L
#define SQLE_TABLE_MUST_BE_EMPTY                    -116L
#define SQLE_NO_PRIMARY_KEY                         -118L
#define SQLE_PRIMARY_KEY_COLUMN_DEFINED             -119L
#define SQLE_ALTER_CLAUSE_CONFLICT                  -125L
#define SQLE_PRIMARY_KEY_TWICE                      -126L
#define SQLE_COLUMN_IN_INDEX                        -127L
#ifdef SAINT
#define SQLE_USER_OWNS_TABLES                       -128L
#endif
#define SQLE_IDENTIFIER_TOO_LONG                    -250L
#define SQLE_DUPLICATE_FOREIGN_KEY                  -251L
#define SQLE_INDEX_NOT_FOUND                        -183L
#define SQLE_MESSAGE_ALREADY_EXISTS                 -610L
#define SQLE_ALREADY_HAS_GRANT_PERMS                -120L
#define SQLE_PERMISSION_DENIED                      -121L
#define SQLE_GROUP_CYCLE                            -122L
#define SQLE_NOT_A_GROUP                            -123L
#define SQLE_ALREADY_HAS_GROUP_MEMBERSHIP           -312L
#define SQLE_INVALID_STATEMENT                      -130L
#define SQLE_SYNTAX_ERROR                           -131L
#define SQLE_STATEMENT_ERROR                        -132L
#define SQLE_INVALID_STATEMENT_TYPE                 -133L
#define SQLE_NOT_IMPLEMENTED                        -134L
#define SQLE_TSQL_FEATURE_NOT_SUPPORTED             -611L
#define SQLE_LANGUAGE_EXTENSION                     -135L
#define SQLE_STMT_NOT_ALLOWED_IN_PASSTHROUGH        -707L
#define SQLE_NOT_SUPPORTED_IN_ULTRALITE             -749L
#define SQLE_UNCOMMITTED_TRANSACTIONS               -755L
#define SQLE_UPLOAD_FAILED_AT_SERVER                -794L
#define SQLE_DOWNLOAD_CONFLICT                      -839L
#define SQLE_MOBILINK_COMMUNICATIONS_ERROR          -1305L
#define SQLE_CANNOT_CHANGE_USER_NAME                -867L
#define SQLE_SERVER_SYNCHRONIZATION_ERROR           -857L
#define SQLE_OMNI_FEATURE_NOT_SUPPORTED             -1139L
#define SQLE_DBSPACE_NOT_FOUND                      -138L
#define SQLE_DEFAULT_DBSPACE_NOT_FOUND              -1068L
#define SQLE_CORRELATION_NAME_AMBIGUOUS             -139L
#define SQLE_UNKNOWN_USERID                         -140L
#define SQLE_TABLE_NOT_FOUND                        -141L
#define SQLE_CORRELATION_NAME_NOT_FOUND             -142L
#define SQLE_INVALID_CORRELATION_FOR_ROWID          -1113L
#define SQLE_INVALID_ROWID_PLACEMENT                -1115L
#define SQLE_COLUMN_NOT_FOUND                       -143L
#define SQLE_COLUMN_NOT_FOUND_IN_TABLE              -834L
#define SQLE_COLUMN_AMBIGUOUS                       -144L
#define SQLE_FOREIGN_KEY_NAME_NOT_FOUND             -145L
#define SQLE_CANNOT_JOIN                            -146L
#define SQLE_AMBIGUOUS_JOIN                         -147L
#define SQLE_OUTER_JOIN_CYCLE                       -136L
#define SQLE_CORRELATION_NAME_NEEDED                -137L
#define SQLE_UNKNOWN_FUNC                           -148L
#define SQLE_INVALID_GROUP_SELECT                   -149L
#define SQLE_NO_CONSTANTS_IN_GROUP_BY               -928L
#define SQLE_INVALID_GROUPING_AGGREGATE             -962L
#define SQLE_TOO_MANY_GROUPING_EXPRESSIONS          -944L
#define SQLE_AGGREGATES_NOT_ALLOWED                 -150L
#define SQLE_SUBQUERY_SELECT_LIST                   -151L
#define SQLE_INVALID_ORDER                          -152L
#define SQLE_INVALID_UNION                          -153L
#define SQLE_MESSAGE_NOT_FOUND                      -612L
#define SQLE_USER_TYPE_NOT_FOUND                    -613L
#define SQLE_SEQUENCE_NOT_FOUND                     -1359L
#define SQLE_INVALID_SEQUENCE_OPERATION             -1353L
#define SQLE_SEQUENCE_CURRVAL_NOT_DEFINED           -1363L
#define SQLE_SEQUENCE_ALREADY_EXISTS                -1354L
#define SQLE_SEQUENCE_EXHAUSTED                     -1355L
#define SQLE_INVALID_SEQUENCE_DEFINITION            -1356L
#define SQLE_DUPLICATE_SEQUENCE_OPTION              -1357L
#define SQLE_INVALID_ALTER_SEQUENCE                 -1510L
#define SQLE_USER_OWNS_MESSAGES_OR_DATATYPES        -614L
#define SQLE_USER_OWNS_REPLICATED_OBJECTS           -731L
#define SQLE_WRONG_PARAMETER_COUNT                  -154L
#define SQLE_INVALID_PARAMETER_NAME                 -615L
#define SQLE_VARIABLE_INVALID                       -155L
#define SQLE_EXPRESSION_ERROR                       -156L
#define SQLE_CONVERSION_ERROR                       -157L
#define SQLE_CONVERSION_ERROR_LOAD_TABLE            -162L
#define SQLE_OVERFLOW_ERROR                         -158L
#define SQLE_INVALID_COLUMN_NUMBER                  -159L
#define SQLE_DESCRIBE_NONSELECT                     -160L
#define SQLE_INVALID_DESCRIBE_TYPE                  -161L
#define SQLE_CURSOR_NOT_DECLARED                    -170L
#define SQLE_OPEN_CURSOR_ERROR                      -171L
#define SQLE_CURSOR_ALREADY_OPEN                    -172L
#define SQLE_CURSOR_NOT_OPEN                        -180L
#define SQLE_CURSOR_INVALID_STATE                   -853L
#define SQLE_NO_INDICATOR                           -181L
#define SQLE_SQLDA_TOO_SMALL                        -182L
#define SQLE_TOO_MANY_RECORDS                       -185L
#define SQLE_SUBQUERY_RESULT_NOT_UNIQUE             -186L
#define SQLE_CURSOROP_NOT_ALLOWED                   -187L
#define SQLE_NOT_ENOUGH_HOST_VARS                   -188L
#define SQLE_NOT_FOUND_IN_INDEX                     -189L
#define SQLE_NON_UPDATEABLE_COLUMN                  -190L
#define SQLE_CANNOT_MODIFY                          -191L
#define SQLE_NON_UPDATEABLE_VIEW                    -192L
#define SQLE_PRIMARY_KEY_NOT_UNIQUE                 -193L
#define SQLE_INVALID_FOREIGN_KEY                    -194L
#define SQLE_COLUMN_CANNOT_BE_NULL                  -195L
#define SQLE_COLUMN_CANNOT_BE_NULL_LOAD_TABLE       -184L
#define SQLE_INDEX_NOT_UNIQUE                       -196L
#define SQLE_NO_CURRENT_ROW                         -197L
#define SQLE_PRIMARY_KEY_VALUE_REF                  -198L
#define SQLE_ONLY_ONE_TABLE                         -199L
#define SQLE_INVALID_COLUMN_VALUE                   -209L
#define SQLE_ROW_UPDATED_SINCE_READ                 -208L
#define SQLE_WRONG_NUM_OF_INSERT_COLS               -207L
#define SQLE_VARIABLE_NOT_FOUND                     -260L
#define SQLE_VARIABLE_EXISTS                        -261L
#define SQLE_LABEL_NOT_FOUND                        -262L
#define SQLE_INVALID_FETCH_POSITION                 -263L
#define SQLE_WRONG_NUM_OF_FETCH_VARIABLES           -264L
#define SQLE_PROCEDURE_NOT_FOUND                    -265L
#define SQLE_ATOMIC_OPERATION                       -267L
#define SQLE_TRIGGER_NOT_FOUND                      -268L
#define SQLE_COLUMN_IN_TRIGGER                      -269L
#ifdef SAINT
#define SQLE_USER_OWNS_PROCEDURES                   -270L
#endif
#define SQLE_USER_OWNS_PROCEDURES_IN_USE            -750L
#define SQLE_USER_OWNS_SEQUENCES_IN_USE             -1367L
#define SQLE_USER_OWNS_TABLES_IN_USE                -751L
#define SQLE_TRIGGER_DEFN_CONFLICT                  -271L
#define SQLE_INVALID_TRIGGER_COL_REFS               -272L
#define SQLE_INVALID_TRIGGER_STATEMENT              -273L
#define SQLE_NESTING_TOO_DEEP                       -274L
#define SQLE_PUBLICATION_NOT_FOUND                  -280L
#define SQLE_TABLE_HAS_PUBLICATIONS                 -281L
#define SQLE_SUBSCRIPTION_NOT_UNIQUE                -282L
#define SQLE_SUBSCRIPTION_NOT_FOUND                 -283L
#define SQLE_ONLY_ONE_PUBLISHER                     -284L
#define SQLE_NOT_REMOTE_USER                        -285L
#define SQLE_NOT_REMOTE_TYPE                        -286L
#define SQLE_PASSTHROUGH_INCONSISTENT               -287L
#define SQLE_REMOTE_STATEMENT_FAILED                -288L
#define SQLE_CONSOLIDATED_USER_ALREADY_EXISTS       -289L
#define SQLE_SYNCHRONIZATION_NOT_FOUND              -767L
#define SQLE_SYNC_SITE_NOT_FOUND                    -843L
#define SQLE_CANNOT_SUBSCRIBE                       -768L
#define SQLE_CANNOT_MODIFY_SYNC_AS_PUB              -769L
#define SQLE_CANNOT_MODIFY_PUB_AS_SYNC              -770L
#define SQLE_CANNOT_SYNC_TABLE_WITHOUT_PK           -777L
#define SQLE_PK_NOT_IN_SYNC_ARTICLE                 -778L
#define SQLE_BLOB_IN_SYNC_TABLE_PK                  -779L
#define SQLE_ARTICLE_PK_CANNOT_BE_UPDATED           -780L
#define SQLE_SAME_EXCLUSIVE_APP_RUNNING             -782L
#define SQLE_SAME_APP_RUNNING                       -783L
#define SQLE_CANNOT_REG_CONN                        -784L
#define SQLE_DEREG_APP_NOT_FOUND                    -785L
#define SQLE_DEREG_APP_IN_USE                       -786L
#define SQLE_CONN_ALREADY_REGISTERED                -787L
#define SQLE_NOT_UNIQUE_CONN_REG_LABEL              -788L
#define SQLE_APP_REG_COOKIE_EXHAUSTED               -789L
#define SQLE_CONN_REG_AUTO_LABEL_EXHAUSTED          -790L
#define SQLE_BAD_SYNC_OPTION_VALUE                  -797L
#define SQLE_SYNC_OPTION_NOT_FOUND                  -805L
#define SQLE_SYNC_OPTION_TOO_LONG                   -809L
#define SQLE_SYNC_CONTAINS_TABLE                    -819L
#define SQLE_TABLE_ALREADY_INCLUDED                 -822L
#define SQLE_CONFLICTING_PUB_TYPE                   -1060L
#define SQLE_CANNOT_UNIQUELY_IDENTIFY_ROWS          -295L
#define SQLE_ERROR_NUMBER_OUT_OF_RANGE              -296L
#define SQLE_INVALID_FORMAT_STRING_ARG_NUM          -294L
#define SQLE_INVALID_OPTION                         -200L
#define SQLE_INVALID_OPTION_SETTING                 -201L
#define SQLE_LOCKED                                 -210L
#define SQLE_MUST_BE_ONLY_CONNECTION                -211L
#define SQLE_CHECKPOINT_REQUIRES_UNDO               -212L
#define SQLE_TABLE_IN_USE                           -214L
#define SQLE_PROCEDURE_IN_USE                       -215L
#define SQLE_SEQUENCE_IN_USE                        -1366L
#define SQLE_LOCK_TIMEOUT                           -1175L
#define SQLE_SAVEPOINT_NOTFOUND                     -220L
#define SQLE_ROLLBACK_NOT_ALLOWED                   -221L
#define SQLE_RESULT_NOT_ALLOWED                     -222L
#define SQLE_SAVEPOINTS_REQUIRE_UNDO                -213L
#define SQLE_PP_DBLIB_MISMATCH                      -230L
#define SQLE_DBLIB_ENGINE_MISMATCH                  -231L
#define SQLE_UNKNOWN_BACKUP_OPERATION               -240L
#define SQLE_BACKUP_NOT_STARTED                     -241L
#define SQLE_BACKUP_CANNOT_RENAME_LOG_YET           -242L
#define SQLE_BACKUP_UNABLE_TO_DELETE_FILE           -243L
#define SQLE_LOG_TRUNCATED                          -244L
#define SQLE_USER_DEFINED_EXCEPTION                 -297L
#define SQLE_DOUBLE_REQUEST                         -298L
#define SQLE_INTERRUPTED                            -299L
#define SQLE_ERROR                                  -300L
#define SQLE_DATABASE_ERROR                         -301L
#define SQLE_TERMINATED_BY_USER                     -302L
#define SQLE_DISK_WRITE_FAILED                      -303L
#define SQLE_DEVICE_FULL                            -304L
#define SQLE_DEVICE_ERROR                           -305L
#define SQLE_DEADLOCK                               -306L
#define SQLE_THREAD_DEADLOCK                        -307L
#define SQLE_CONNECTION_TERMINATED                  -308L
#define SQLE_MEMORY_ERROR                           -309L
#define SQLE_LOG_CORRUPTED                          -311L
#define SQLE_UNSUPPORTED_LOAD_FORMAT                -601L
#define SQLE_UNSUPPORTED_UNLOAD_FORMAT              -1530L
#define SQLE_CANNOT_ACCESS_FILE                     -602L
#define SQLE_CANNOT_UNLOAD_A_VIEW                   -643L
#define SQLE_DBSPACE_FULL                           -604L
#define SQLE_ACCESS_BEYOND_END_OF_MAX_DBSPACE       -605L
#define SQLE_PATTERN_TOO_LONG                       -606L
#define SQLE_CANNOT_STOP_SERVER                     -607L
#define SQLE_INVALID_TEXTPTR_VALUE                  -608L
#define SQLE_INVALID_TEXT_IMAGE_DATATYPE            -609L
#define SQLE_WRITETEXT_TABLE_WITH_IMV               -1203L
#define SQLE_TOO_MANY_COLUMNS_IN_TABLE              -616L
#define SQLE_EXTERNAL_CALLS_NOT_SUPPORTED           -617L
#define SQLE_EXTERNAL_PLATFORM_FAILURE              -618L
#define SQLE_REQUIRE_DLL_NAME                       -619L
#define SQLE_COULD_NOT_LOAD_LIBRARY                 -620L
#define SQLE_COULD_NOT_FIND_FUNCTION                -621L
#define SQLE_ERROR_CALLING_FUNCTION                 -622L
#define SQLE_DDL_NOT_ALLOWED_IN_PROCEDURES          -623L
#define SQLE_DATATYPE_NOT_ALLOWED                   -624L
#define SQLE_TOO_MANY_PARAMETERS                    -625L
#define SQLE_THREAD_START_FAILURE                   -626L
#define SQLE_INVALID_SYNTAX_EXTENSION               -627L
#define SQLE_DIV_ZERO_ERROR                         -628L
#define SQLE_INVALID_ESCAPE_CHAR                    -629L
#define SQLE_INVALID_ESCAPE_SEQ                     -630L
#define SQLE_INVALID_REGULAR_EXPRESSION             -1135L
#define SQLE_INVALID_USE_OF_ESCAPE_CHARACTER        -1136L
#define SQLE_ESCAPE_CHARACTER_CONFLICT              -1137L
#define SQLE_RAISERROR_STMT                         -631L
#define SQLE_WITH_CHECK_OPTION_VIOLATION            -632L
#define SQLE_READ_ONLY_CURSOR                       -633L
#define SQLE_UNTERMINATED_C_STR                     -634L
#define SQLE_SYNTAX_EXTENSION_WARNING               107L
#define SQLE_NO_COLUMN_PERMS_FOR_VIEWS              -635L
#define SQLE_NULL_VALUE_ELIMINATED                  109L
#define SQLE_DUPLICATE_REFERENCING_COLUMN           -636L
#define SQLE_DUPLICATE_INSERT_COLUMN                -637L
#define SQLE_STRING_RIGHT_TRUNCATION                -638L
#define SQLE_PARAMETER_NAME_MISSING                 -639L
#define SQLE_INVALID_DESCRIPTOR_INDEX               -640L
#define SQLE_ERROR_IN_ASSIGNMENT                    -641L
#define SQLE_INVALID_DESCRIPTOR_NAME                -642L
#define SQLE_BACKUP_PAGE_INCOMPLETE                 110L
#define SQLE_NOT_PUBLIC_ID                          -202L
#define SQLE_MORE_INFO                              112L
#define SQLE_TOO_MANY_COLUMNS_DELETED               -124L
#define SQLE_TEMPORARY_NOT_ALLOWED                  -203L
#define SQLE_INVALID_OPTION_ON_CONNECT              113L
#define SQLE_OPTION_REQUIRES_DBA                    -204L
#define SQLE_OPTION_IS_TEMP_ONLY                    -216L
#define SQLE_OPTION_IN_PROCEDURE                    -217L
#define SQLE_INVALID_STANDARD_LOGON                 -205L
#define SQLE_INVALID_INTEGRATED_LOGON               -206L
#define SQLE_LOGON_MODE_NOT_PERMITTED               -1074L
#define SQLE_INTEGRATED_LOGON_FAILED                -245L
#define SQLE_INTEGRATED_LOGON_TOO_MANY_MAPPINGS     -1003L
#define SQLE_KERBEROS_LOGON_FAILED                  -1069L
#define SQLE_KERBEROS_LOGONS_UNSUPPORTED            -1070L
#define SQLE_PREEMPTED                              -503L
#define SQLE_RETRY                                  -504L
#define SQLE_INTEGRATED_LOGON_UNSUPPORTED           -246L
#define SQLE_INTEGRATED_LOGON_GUESTMAP              -247L
#define SQLE_LOGON_SYSMAP                           -248L
#define SQLE_LOGON_MAPPED                           -249L
#define SQLE_LOGON_UNMAPPED                         -313L
#define SQLE_STORE_NOT_LOADED                       -646L
#define SQLE_STORE_ENTRY_NOT_FOUND                  -647L
#define SQLE_STORE_VERSION_MISMATCH                 -711L
#define SQLE_INVALID_DBSPACE_FOR_CREATE             -648L
#define SQLE_FIELD_NOT_FOUND                        -93L
#define SQLE_CHECKSUMS_NOT_ENABLED                  -971L
#define SQLE_INVALID_INDEX_TYPE                     -650L
#define SQLE_DROP_DATABASE_FAILED                   -651L
#define SQLE_NO_PROFILE_FILE                        -654L
#define SQLE_GEN_PARSE_ERROR                        -655L
#define SQLE_DATABASE_ACTIVE                        -664L
#define SQLE_DATABASE_NEEDS_RECOVERY                -665L
#define SQLE_NO_SCROLL_CURSOR                       -668L
#define SQLE_METHOD_CANNOT_BE_CALLED                -669L
#define SQLE_DATABASE_UPGRADE_FAILED                -672L
#define SQLE_DATABASE_UPGRADE_NOT_POSSIBLE          -673L
#define SQLE_DBO_DOES_NOT_OWN_ROWGENERATOR          -826L
#define SQLE_USER_TABLES_IN_SYSTEM_RANGE            -827L
#define SQLE_INVALID_CURSOR_RANGE                   -674L
#define SQLE_INVALID_TRANSACTION_ISOLATION          -676L
#define SQLE_NO_COLUMN_NAME                         -163L
#define SQLE_TABLE_HAS_REFACTION                    -677L
#define SQLE_AMBIGUOUS_INDEX_NAME                   -678L
#define SQLE_INVALID_TSQL_OJ_EXPRESSION             -680L
#define SQLE_INVALID_TSQL_JOIN_TYPE                 -681L
#define SQLE_DUPLICATE_CURSOR_NAME                  -683L
#define SQLE_ROLLBACK_ON_PREFETCH                   -684L
#define SQLE_BLOCKING_OTHERS_ROLLBACK               -1344L
#define SQLE_RESOURCE_GOVERNOR_EXCEEDED             -685L
#define SQLE_BAD_PARAM_INDEX                        -689L
#define SQLE_BACKUP_NOT_LOADED                      -691L
#define SQLE_BACKUP_ENTRY_NOT_FOUND                 -692L
#define SQLE_BACKUP_ERROR                           -697L
#define SQLE_SQLDA_INCONSISTENT                     -700L
#define SQLE_SQLDA_INVALID_DATATYPE                 -759L
#define SQLE_INVALID_SQL_IDENTIFIER                 -760L
#define SQLE_CANNOT_TRUNCATE_VIEW                   -702L
#define SQLE_COMPUTED_COLUMN_WRITE_ATTEMPTED        -703L
#define SQLE_TEXT_OPERATION_ON_VIEW                 -708L
#define SQLE_COMPUTED_COLUMNS_NOT_SUPPORTED         -709L
#define SQLE_CAPABILITY_NOT_FOUND                   -761L
#define SQLE_RENAME_WITH_VERIFY_NOT_ALLOWED         -1398L
#define SQLE_RESTORE_INCONSISTENT                   -715L
#define SQLE_RESTORE_INVALID_FORMAT                 -716L
#define SQLE_RESTORE_UNABLE_TO_OPEN                 -717L
#define SQLE_RESTORE_UNABLE_TO_WRITE                -718L
#define SQLE_RESTORE_UNABLE_TO_START                -719L
#define SQLE_CANNOT_VALIDATE_OBJECT                 -720L
#define SQLE_CANNOT_OPTIMIZE_QUERY                  -727L
#define SQLE_CANNOT_PERFORM_CHAR_TRANSLATION        114L
#define SQLE_UNSUPPORTED_CHARACTER_SET_ERROR        -869L
#define SQLE_UNSUPPORTED_CHARACTER_SET_WARNING      115L
#define SQLE_UNSUPPORTED_LANGUAGE                   116L
#define SQLE_UNSUPPORTED_CHARSET_AND_LANGUAGE       117L

#if !defined( UNDER_CE )

#define SQLE_OMNI_CONNECT_ERROR                     -656L
#define SQLE_OMNI_CIRCULAR_CONNECT                  -657L
#define SQLE_OMNI_READONLY                          -658L
#define SQLE_OMNI_SERVER_NOT_FOUND                  -659L
#define SQLE_OMNI_REMOTE_ERROR                      -660L
#define SQLE_OMNI_BACKWARDS_CURSOR                  -661L
#define SQLE_OMNI_RMT_TABLE_NOTFOUND                -666L
#define SQLE_OMNI_RMT_COLUMNS_NOTFOUND              -667L
#endif

#define SQLE_OMNI_DEBUG                             -682L

#if !defined( UNDER_CE )

#define SQLE_OMNI_AUTOINC_NOT_SUPPORTED             -698L
#define SQLE_OMNI_SERVER_NOT_CAPABLE                -706L
#define SQLE_OMNI_EXTLOGIN_NOT_FOUND                -712L
#define SQLE_USER_HAS_EXTERNLOGINS                  -1220L
#define SQLE_OMNI_DATATYPE_MISMATCH                 -721L
#define SQLE_OMNI_NOSUCH_COLUMN                     -722L
#define SQLE_OMNI_LENGTH_MISMATCH                   -723L
#define SQLE_OMNI_NULL_MISMATCH                     -724L
#define SQLE_OMNI_IDENTITY_MISMATCH                 -725L
#define SQLE_OMNI_RMT_TABLE_NOTUNIQUE               -726L
#define SQLE_OMNI_COMPUTED_NOT_SUPPORTED            -732L
#define SQLE_OMNI_UNSUPPORTED_DATATYPE              -736L
#define SQLE_OMNI_EXPRESSION_IN_PROC                -823L
#define SQLE_OMNI_FILE_SYSTEM_ERROR                 -1066L

#endif

#if !defined( UNDER_CE )

#define SQLE_IQ_PATH_SYNTAX_ERROR                   -687L

#define SQLE_IQ_LOG_REQUIRED                        -933L

#endif

#if !defined( NO_EXTENV )

#define SQLE_UNHANDLED_EXTENV_EXCEPTION             -91L
#define SQLE_BAD_CLASS_FILE                         -92L
#define SQLE_BAD_JAR_FILE                           -730L
#define SQLE_INVALID_FIELD_REFERENCE                -94L
#define SQLE_NAMESPACE_HEAP_EXHAUSTED               -164L
#define SQLE_JAVA_VM_HEAP_EXHAUSTED                 -165L
#define SQLE_FIELD_CANNOT_BE_NULL                   -649L
#define SQLE_CANNOT_DECOMPRESS_CLASS                -652L
#define SQLE_CLASS_MEMBER_OF_JAR                    -653L
#define SQLE_JAVA_SERIALIZATION_ERROR               -662L
#define SQLE_JAVA_DESERIALIZATION_ERROR             -663L
#define SQLE_BAD_CLASS_BYTE_CODE                    -670L
#define SQLE_EXTENV_NOT_STARTED                     -675L
#define SQLE_CANNOT_INDEX_ON_JAVA_CLASS             -704L
#define SQLE_PROCEDURE_RETURNS_VOID                 -705L
#define SQLE_INVALID_COMPARISON                     -710L
#define SQLE_EXTERN_ENV_NOT_FOUND                   -1205L
#define SQLE_EXTERN_ENV_UPGRADE                     -1206L
#define SQLE_EXTERN_ENV_NO_RESULT_SET_SUPPORT       -1213L

#endif

#define SQLE_NON_UPDATEABLE_EXT_TAB                 -728L
#define SQLE_UNENFORCEABLE_FOREIGN_KEY              -729L
#define SQLE_TOO_MANY_NULL_COLUMNS                  -733L
#define SQLE_CANNOT_UPDATE_NULL_ROW                 -734L
#define SQLE_CANNOT_UPDATE_TWO_TABLES_IMV           -1192L
#define SQLE_INVALID_USER_ESTIMATE                  118L
#define SQLE_SIGNATURE_MISMATCH                     -737L
#define SQLE_UNKNOWN_OPTION                         120L
#define SQLE_DB_INIT_NOT_CALLED                     -739L
#define SQLE_FAILED_TO_CREATE_STREAMS_ENV           -740L
#define SQLE_IQ_INVALID_COMMAND_LINE                -744L
#define SQLE_IQ_MEMORY_MANAGER_FAILED               -745L
#define SQLE_IQ_SYSTEM_V_FAILURE                    -746L
#define SQLE_READ_ONLY_DATABASE                     -757L
#define SQLE_NOT_SYNC_TYPE                          -765L
#define SQLE_UNABLE_TO_OPEN_BACKUP_LOG              119L
#define SQLE_VIEW_OVER_TEMP_OBJECT                  -766L
#define SQLE_EVENT_NOT_FOUND                        -771L
#define SQLE_EVENT_ALREADY_EXISTS                   -772L
#define SQLE_SCHEDULE_NOT_FOUND                     -773L
#define SQLE_SCHEDULE_ALREADY_EXISTS                -774L
#define SQLE_INVALID_EVENT_DAY                      -791L
#define SQLE_INVALID_EVENT_TIME                     -792L
#define SQLE_INVALID_EVENT_START                    -793L
#define SQLE_EVENT_START_TIME_IN_PAST               -1128L
#define SQLE_MAX_ROW_SIZE_EXCEEDED                  -1132L
#define SQLE_DTC_TRANSACTIONS_NOT_SUPPORTED         -799L
#define SQLE_CANNOT_COMMIT_OR_ROLLBACK_WHILE_ENLISTED -800
#define SQLE_CANNOT_ENLIST_WHILE_ALREADY_ENLISTED   -801L
#define SQLE_CANNOT_ENLIST_WITH_UNCOMMITTED_DATA    -802L
#define SQLE_FAILED_TO_ENLIST                       -803L
#define SQLE_FAILED_TO_REENLIST                     -804L
#define SQLE_EVENT_TYPE_NOT_FOUND                   -806L
#define SQLE_HOSTVARS_IN_BATCH                      -807L
#define SQLE_TEST_HARNESS                           -808L
#define SQLE_EXTENV_OBJECT_NOT_FOUND                -810L
#define SQLE_JAR_NOT_FOUND                          -811L
#define SQLE_NO_MATCHING_SELECT_ITEM                -812L
#define SQLE_NON_UPDATEABLE_CURSOR                  -813L
#define SQLE_CANNOT_UPDATE_ORDER_BY_COLUMN          -814L
#define SQLE_UPDATE_NOT_IN_SELECT                   -815L
#define SQLE_TOO_MANY_TEMP_TABLES                   -817L
#define SQLE_INCOMPATIBLE_EXTERNAL_CALL             -818L
#define SQLE_INVALID_POSITION                       -820L
#define SQLE_DBSPACE_FOR_TABLE_UNAVAILABLE          -821L
#define SQLE_INVALID_CORRELATION_NAME_REFERENCE     -824L
#define SQLE_PREVIOUS_ERROR_LOST                    -825L
#define SQLE_RECORDING_CONFLICT_DETECTED            -828L
#define SQLE_ALIAS_NOT_UNIQUE                       -830L
#define SQLE_ALIAS_NOT_YET_DEFINED                  -831L
#define SQLE_CONNECTION_ERROR                       -832L
#define SQLE_ROW_REMODIFIED_OR_DELETED              -833L
#define SQLE_EVENT_IN_USE                           -835L
#define SQLE_PROCEDURE_NO_LONGER_VALID              -836L
#define SQLE_TRIGGER_NO_LONGER_VALID                -837L
#define SQLE_BAD_ENCRYPTION_KEY                     -840L
#define SQLE_INVALID_COLUMN_QUALIFICATION           -845L
#define SQLE_INVALID_SET_CLAUSE                     -846L
#define SQLE_AMBIGUOUS_TABLE_NAME                   -852L
#define SQLE_AMBIGUOUS_SEQUENCE_NAME                -1358L
#define SQLE_INVALID_ORDERBY_COLUMN                 -854L
#define SQLE_CURSOR_OPTIONS_CHANGED                 121L
#define SQLE_AMBIGUOUS_TRIGGER_NAME                 -855L
#define SQLE_INVALID_SQLLEN                         -856L
#define SQLE_HISTOGRAMS_NOT_SUPPORTED_ON_OBJECT     -858L
#define SQLE_DBSPACE_NOT_CALIBRATED                 -860L
#define SQLE_MULTIPLE_AGGREGATE_COLUMNS             -861L
#define SQLE_INVALID_AGGREGATE_PLACEMENT            -862L
#define SQLE_INVALID_DISTINCT_AGGREGATE             -863L
#define SQLE_INVALID_NUMBER                         -864L
#define SQLE_BAD_RESULT_SET                         -866L
#define SQLE_UNKNOWN_CHARSET                        -868L
#define SQLE_INVALID_ENCODING_FOR_COLLATION         -1072L
#define SQLE_INVALID_NCHAR_COLLATION                -1073L
#define SQLE_FAILED_TO_START_CONVERTER              -870L
#define SQLE_FAILED_TO_START_CONVERTER_2_CHARSETS   -891L
#define SQLE_COLLATION_NOT_SUPPORTED                -1116L
#define SQLE_CHAR_COLLATION_NOT_SUPPORTED           -1140L
#define SQLE_NCHAR_COLLATION_NOT_SUPPORTED          -1141L
#define SQLE_ICU_NOT_AVAILABLE                      -1076L
#define SQLE_TOO_MANY_RESULT_SETS                   -873L
#define SQLE_NO_RESULT_SET                          -872L
#define SQLE_JAVA_VM_INSUFFICIENT_CACHE             -686L
#define SQLE_NO_XML_IDENTIFIER                      -874L
#define SQLE_CANNOT_JOIN_TABEXPR                    -875L
#define SQLE_NONDETERMINISTIC_RESULT                122L
#define SQLE_SETUSER_NOT_IN_PROCEDURES              -877L
#define SQLE_CLUSTERED_INDEX_NOT_ALLOWED            -878L
#define SQLE_ILLEGAL_MULTIBYTE_ERROR                -879L
#define SQLE_ILLEGAL_MULTIBYTE_WARNING              125L
#define SQLE_SIMPLE_SUBSTITUTION_ERROR              -881L
#define SQLE_SIMPLE_SUBSTITUTION_WARNING            127L
#define SQLE_COLLATION_DEFAULT_WARNING              201L
#define SQLE_FAILED_TO_CONVERT_CHARSET              -1075L
#define SQLE_CHARACTER_CONVERSION_REPORT_NOT_AVAILABLE -883L
#define SQLE_TOO_MANY_VIRTUAL_INDEX_COLUMNS         -887L
#define SQLE_USING_VIRTUAL_INDEXES                  129L
#define SQLE_XML_PARSER_ERROR                       -888L
#define SQLE_XQUERY_PARSER_ERROR                    -892L
#define SQLE_NONDETERMINISTIC_FUNCTION              -889L
#define SQLE_SYNTACTIC_LIMIT                        -890L
#define SQLE_BAD_OPENXML_FLAG                       -893L
#define SQLE_STMT_NOT_ALLOWED_IN_PLAN               -894L
#define SQLE_STMT_NOT_ALLOWED_FOR_NOEXEC_PLAN       -1176L
#define SQLE_HTML_PLAN_NOT_SUPPORTED                -1177L
#define SQLE_UNSET_PUBLIC_ID                        -896L
#define SQLE_CANNOT_DUMP_STRING_HISTOGRAM           132L
#define SQLE_BAD_FOR_XML_EXPLICIT_TAG               -897L
#define SQLE_BAD_FOR_XML_EXPLICIT_DIRECTIVE         -898L
#define SQLE_BAD_FOR_XML_EXPLICIT_COLUMN_NAME       -899L
#define SQLE_EXPLICIT_TAG_NOT_OPEN                  -900L
#define SQLE_UNDECLARED_FOR_XML_EXPLICIT_TAG        -901L
#define SQLE_FOR_XML_EXPLICIT_TOO_FEW_COLUMNS       -902L
#define SQLE_FOR_XML_EXPLICIT_NAMED_CDATA           -903L
#define SQLE_INVALID_ORDERBY_IN_AGGREGATE           -904L
#define SQLE_INVALID_XQUERY_CONSTRUCTOR             -905L
#define SQLE_XMLGEN_EVALUATION_FAILURE              -906L
#define SQLE_NO_SQLX_ARGUMENT_NAME                  -907L
#define SQLE_ULTRALITE_OBJ_CLOSED                   -908L
#define SQLE_SYSTEM_COMMAND_FAILED                  -910L
#define SQLE_CONTROL_CHARACTER_IN_XML_OUTPUT        -911L
#define SQLE_XQUERY_MEMORY_ERROR                    -912L
#define SQLE_AUDITING_WITHOUT_TRANSACTION_LOG       -913L
#define SQLE_COMMON_TABLE_EXPRESSION_CYCLE          -914L
#define SQLE_SERVICE_TYPE_REQUIRED                  -915L
#define SQLE_UNKNOWN_SERVICE_TYPE                   -916L
#define SQLE_SERVICE_IN_USE                         -924L
#define SQLE_SERVICE_REQUIRES_USER_NAME             -918L
#define SQLE_SERVICE_ALREADY_EXISTS                 -919L
#define SQLE_SERVICE_NOT_FOUND                      -920L
#define SQLE_INVALID_RECURSION                      -921L
#define SQLE_NO_RECURSIVE_COLUMN_LIST               -922L
#define SQLE_RECURSIVE_KEYWORD_REQUIRED             -938L
#define SQLE_BAD_RECURSIVE_COLUMN_CONVERSION        -945L
#define SQLE_TOO_MANY_RECURSIVE_ITERATIONS          -923L
#define SQLE_INVALID_SERVICE_NAME                   -925L
#define SQLE_HOSTVAR_MUST_BE_NAMED                  -926L
#define SQLE_SERVICE_STATEMENT_MISMATCH             -927L
#define SQLE_SERVICE_STATEMENT_INVALID              -1269L
#define SQLE_CONSTRAINT_NOT_FOUND                   -929L
#define SQLE_AMBIGUOUS_CONSTRAINT                   -930
#define SQLE_SERVICE_AUTH_REQUIRED                  -931L
#define SQLE_SERVICE_ATTR_NOT_ALLOWED               -1027L
#define SQLE_SERVICE_ATTR_COEXIST                   -1026L
#define SQLE_SERVICE_PARM_INVALID_VALUE             -1022L
#define SQLE_SERVICE_PARM_MISSING_VALUE             -1023L
#define SQLE_SERVICE_PARM_UNSUPPORTED_PROPERTY      -1024L
#define SQLE_SERVICE_PARM_DUPLICATE_PROPERTY        -1025L
#define SQLE_TOO_MANY_CONSTRAINTS                   -936L
#define SQLE_INVALID_CONSTRAINT_REF                 -937L
#define SQLE_INVALID_HINT                           -970L
#define SQLE_INVALID_HTTP_OPTION_SETTING            -939L
#define SQLE_INVALID_HTTP_HEADER_SETTING            -940L
#define SQLE_INVALID_SOAP_HEADER_SETTING            -1114L
#define SQLE_NO_ENCRYPTION_FOR_JCONNECT             -941L
#define SQLE_WORKLOAD_CAPTURE_ALREADY_EXISTS        -942L
#define SQLE_WORKLOAD_CAPTURE_DOES_NOT_EXIST        -943L
#define SQLE_RESULT_SET_NOT_PERMITTED               -946L
#define SQLE_WINDOW_NOT_FOUND                       -947L
#define SQLE_PARTITIONBY_NOT_ALLOWED                -948L
#define SQLE_ORDERBY_NOT_ALLOWED                    -949L
#define SQLE_FRAME_NOT_ALLOWED                      -950L
#define SQLE_FUNCTION_DOES_NOT_ALLOW                -1330L
#define SQLE_FUNCTION_REQUIRES                      -1331L
#define SQLE_CANNOT_ACCESS_SCHEMA_FILE              -951L
#define SQLE_SYNC_STATUS_UNKNOWN                    -952L
#define SQLE_SCHEMA_UPGRADE_NOT_ALLOWED             -953L
#define SQLE_ULTRALITE_DATABASE_NOT_FOUND           -954L
#define SQLE_CONNECTION_ALREADY_EXISTS              -955L
#define SQLE_SYNC_INFO_INVALID                      -956L
#define SQLE_INVALID_FRAME_BOUNDARY                 -957L
#define SQLE_PASSWORD_TOO_LONG                      -958L
#define SQLE_COMPRESSION_ERROR                      -959L
#define SQLE_DECOMPRESSION_ERROR                    -960L
#define SQLE_BASE64_DECODING_ERROR                  -961L
#define SQLE_ILLEGAL_PASSWORD                       -963L
#define SQLE_ILLEGAL_WINDOW_PREDICATE               -964L
#define SQLE_OBSOLETE_ORDERBY_REQUIRED              -965L
#define SQLE_ILLEGAL_COMPOSITE_ORDERBY              -966L
#define SQLE_BACKUP_FILE_EXISTS                     -967L
#define SQLE_BACKUP_UNABLE_TO_OPEN_FILE             -1079L
#define SQLE_ALREADY_HAS_EXEC_PERMS                 -968L
#define SQLE_REQUIRED_OPERATORS_EXCLUDED            -969L
#define SQLE_CONNECTION_RESTORED                    133L
#define SQLE_CURSOR_RESTORED                        134L
#define SQLE_DATABASE_STATE_RESTORED                142L
#define SQLE_STRING_PARM_TOO_LONG                   -973L
#define SQLE_DEVICE_IO_FAILED                       -974L
#define SQLE_INCORRECT_VOLUME_ID                    -975L
#define SQLE_MISSING_ENCRYPTION_DLL                 -976L
#define SQLE_DIRECTORY_INACCESSIBLE                 -978L
#define SQLE_CANNOT_WRITE_FILE                      -979L
#define SQLE_INVALID_URI                            -980L
#define SQLE_UNABLE_TO_CONNECT_TO_HOST              -981L
#define SQLE_REMOTE_CONNECTION_TIMED_OUT            -982L
#define SQLE_HTTP_REQUEST_FAILED                    -983L
#define SQLE_ENCRYPTION_INITIALIZATION_FAILED       -984L
#define SQLE_INVALID_PROCEDURE_TYPE                 -986L
#define SQLE_INVALID_PROCEDURE_SUBTYPE              -987L
#define SQLE_INVALID_HTTP_RESPONSE                  -988L
#define SQLE_INVALID_NAMESPACE_ATTRIBUTE            -989L
#define SQLE_SECURE_CONNECTION_FAILED               -990L
#define SQLE_INVALID_PROCEDURE_ATTRIBUTE            -991L
#define SQLE_HTTP_HEADER_ATTRIBUTE_RESERVED_XXX     -1094L
#define SQLE_HTTP_HEADER_ATTRIBUTE_ASCII            -1095L
#define SQLE_HTTP_HEADER_ATTRIBUTE_MALFORMED        -1096L
#define SQLE_INVALID_ATTRIBUTE_MISMATCH_BRACES      -1129L
#define SQLE_INVALID_ATTRIBUTE_MISSING_COMMA        -1130L
#define SQLE_INVALID_ATTRIBUTE_OPTIONS              -1131L
#define SQLE_CANNOT_REGISTER_LISTENER               -992L
#define SQLE_INVALID_TEMP_TABLE_COMMIT_ACTION       -993L
#define SQLE_INVALID_LOAD_TABLE_WITH_FOREIGN_KEY    -1146L
#define SQLE_TOO_MANY_ARGUMENTS                     -994L
#define SQLE_SELECT_INTO_WARNING_TREATED_AS_ERROR   -995L
#define SQLE_LOCAL_CONNECTION_NOT_FOUND             -996L
#define SQLE_LOCAL_CONNECTION_NOT_TO_CURRENT_DB     -997L
#define SQLE_CANNOT_CLOSE_JDBC_CONNECTION           -998L
#define SQLE_DATABASE_CREATED                       136L
#define SQLE_INVALID_REQUEST_LOG_FORMAT             -999L
#define SQLE_TEMP_SPACE_LIMIT                       -1000L
#define SQLE_NO_DEFAULT_FOR_PARM                    -1001L
#define SQLE_UNRECOGNIZED_OPTION                    -1002L
#define SQLE_FILE_NOT_DB                            -1004L
#define SQLE_FILE_WRONG_VERSION                     -1005L
#define SQLE_FILE_BAD_DB                            -1006L
#define SQLE_CORRUPT_REDO                           -1007L
#define SQLE_CORRUPT_REDO_MIRROR                    -1008L
#define SQLE_CORRUPT_REDO_OR_MIRROR                 -1009L
#define SQLE_EXPECTING_NO_REDO                      -1010L
#define SQLE_UNKNOWN_ENCRYPTION_ALGORITHM           -1011L
#define SQLE_UPGRADE_DATABASE                       -1012L
#define SQLE_LOG_NEWER_THAN_DB                      -1016L
#define SQLE_LOG_NOT_FOUND                          -1017L
#define SQLE_LOG_OFFSETS_DONT_MATCH                 -1018L
#define SQLE_LOG_OLDER_THAN_DB                      -1019L
#define SQLE_LOG_TOO_SHORT                          -1020L
#define SQLE_INVALID_BACKUP_OPERATION               -1021L
#define SQLE_INVALID_BACKUP_PARM_VALUE              -1045L
#define SQLE_INVALID_BACKUP_STATEMENT               -1057L
#define SQLE_ROW_DELETED_TO_MAINTAIN_REFERENTIAL_INTEGRITY 137L
#define SQLE_BACKUP_HAS_UNCOMMITTED_TRANS           -1028L
#define SQLE_MAT_VIEWS_NOT_SUPPORTED                -1029L
#define SQLE_SECURE_CONNECTION_UNAVAILABLE          -1030L
#define SQLE_MATVIEW_SYNTAX_ERROR                   -1031L
#define SQLE_UPDATABLE_MATVIEW_SYNTAX_ERROR         -1032L
#define SQLE_UPDATABLE_MATVIEW_PSNS_ON_CONDITION    -1371L
#define SQLE_UPDATABLE_MATVIEW_OUTERREFERENCE_ON_CONDITION -1507L
#define SQLE_UPDATABLE_MATVIEW_ISNOTNULL            -1508L
#define SQLE_UPDATABLE_MATVIEW_PK                   -1509L
#define SQLE_UPDATABLE_MATVIEW_MISSING_COUNT        -1199L
#define SQLE_UPDATABLE_MATVIEW_MULTIBLE_BLOCK_ERR   -1181L
#define SQLE_UPDATABLE_MATVIEW_ERR                  -1268L
#define SQLE_DELETE_UPDATABLE_MATVIEW_INDEX_ERR     -1184L
#define SQLE_UPDATABLE_MATVIEW_NON_AGGR_INDEX       -1218L
#define SQLE_INVALID_OPERATION_FOR_TBL_WITH_IMV     -1202L
#define SQLE_MAINTENANCE_OF_IMV_FAILED              -1219L
#define SQLE_UPDATABLE_MATVIEW_SUM_NULL_EXPR        -1286L
#define SQLE_UPDATABLE_MATVIEW_COUNT_NULL_EXPR      -1327L
#define SQLE_INVALID_ATTRIBUTE_WITH_TYPE            -1034L
#define SQLE_LOAD_TABLE_ON_MIRRORED_DB              -1035L
#define SQLE_WRONG_DB_ON_ALT_SERVER_NAME            -1036L
#define SQLE_OBJECT_HAS_DEPENDENTS                  -1037L
#define SQLE_VIEW_DISABLED                          -1038L
#define SQLE_CONNECTED_TO_MIRROR_SERVER             -1039L
#define SQLE_VIEW_INVALID                           -1040L
#define SQLE_MATVIEW_NOT_FOUND                      -1041L
#define SQLE_COMMENT_NOT_ALLOWED                    -1042L
#define SQLE_REQUEST_TIMEOUT                        -1043L
#define SQLE_INVALID_NEW_PASSWORD                   -1044L
#define SQLE_ILLEGAL_COLUMN_DEFINITION              -1046L
#define SQLE_ENCRYPTED_TABLES_NOT_SUPPORTED         -1047L
#define SQLE_VALUE_IS_NULL                          -1050L
#define SQLE_CANNOT_CREATE_MATVIEW                  -1051L
#define SQLE_CANNOT_UPDATE_MATVIEW                  -1052L
#define SQLE_IMMEDIATE_MV_REFRESH_NOT_ALLOWED       -1170L
#define SQLE_IMMEDIATE_MV_NO_UNIQUE_INDEX           -1233L
#define SQLE_INVALID_OPTION_VALUE                   -1053L
#define SQLE_SNAPSHOT_ISOLATION_DISABLED            -1054L
#define SQLE_SNAPSHOT_TABLE_CHANGED                 -1061L
#define SQLE_STATEMENT_NOT_ALLOWED_IN_SNAPSHOT      -1062L
#define SQLE_AUDITING_DB_READ_ONLY                  -1063L
#define SQLE_SNAPSHOT_UPDATE_CONFLICT               -1064L
#define SQLE_NON_SNAPSHOT_TRANSACTION               -1065L
#define SQLE_SNAPSHOT_ALREADY_STARTED               -1232L
#define SQLE_FIPS_NOT_AVAILABLE                     -1071L
#define SQLE_CANNOT_USE_MATVIEW                     -1077L
#define SQLE_COMPUTED_COLUMN_CYCLE                  -1078L
#define SQLE_MUST_NOT_BE_REPLICATING                -1080L
#define SQLE_NO_TRACING_LEVELS                      -1081L
#define SQLE_INVALID_TRACING_SPEC                   -1082L
#define SQLE_TRACING_OBJ_NOT_FOUND                  -1083L
#define SQLE_NO_VOLATILE_LEVEL_SPEC                 -1087L
#define SQLE_NO_LOCAL_CONNECTIONS_TO_ENCRYPTED      -1088L
#define SQLE_SECURE_FEATURE                         -1084L
#define SQLE_SECURE_STATEMENT                       -1142L
#define SQLE_DUPLICATE_KEY_COLUMN                   -1085L
#define SQLE_ULTRALITE_WRITE_ACCESS_DENIED          -1086L
#define SQLE_INVALID_SHARED_COMMIT_ACTION           -1089L
#define SQLE_INVALID_PARAMETER_W_PARM               -1090L
#define SQLE_TABLE_CONSTRAINT_VIOLATED              -1091L
#define SQLE_PUBLICATION_PREDICATE_IGNORED          138L
#define SQLE_FEATURE_NOT_ENABLED                    -1092L
#define SQLE_CHAR_FIELD_SIZE_EXCEEDED               -1093L
#define SQLE_ATTACH_TRACING_FAILED                  -1097L
#define SQLE_TRACING_ALREADY_ATTACHED               -1098L
#define SQLE_TCP_CONNECTIONS_NOT_ENABLED            -1372L
#define SQLE_TSQL_OUTER_JOINS_DISABLED              -1099L
#define SQLE_DUPLICATE_OPTION                       139L
#define SQLE_COLUMN_NOT_STREAMABLE                  -1100L
#define SQLE_COLUMN_NOT_INDEXED                     -1101L
#define SQLE_DOWNLOAD_RESTART_FAILED                -1102L
#define SQLE_PARTIAL_DOWNLOAD_NOT_FOUND             -1103L
#define SQLE_TOO_MANY_USERS                         -1104L
#define SQLE_TOO_MANY_PUBLICATIONS                  -1106L
#define SQLE_TOO_MANY_BLOB_REFS                     -1107L
#define SQLE_CANNOT_ACCESS_FILESYSTEM               -1108L
#define SQLE_KEYLESS_ENCRYPTION                     -1109L
#define SQLE_SYNC_NOT_REENTRANT                     -1110L
#define SQLE_SYNC_INFO_REQUIRED                     -1111L
#define SQLE_FILE_VOLUME_NOT_FOUND                  -1112L
#define SQLE_ROW_EXCEEDS_PAGE_SIZE                  -1117L
#define SQLE_CANNOT_CHANGE_ML_REMOTE_ID             -1118L
#define SQLE_UNSUPPORTED_PROPERTY                   -1119L
#define SQLE_DBSPACE_CONTAINS_TABLES                -1120L
#define SQLE_NO_ROOM_TO_GROW_DBSPACE                -1121L
#define SQLE_INVALID_MAXIMUM_PARAMETERS             -1122L
#define SQLE_INVALID_MIMETYPE                       -1123L
#define SQLE_ICU_DLL_VERSION_MISMATCH               -1124L
#define SQLE_CHECK_TRIGGER_CONFLICT                 -1125L
#define SQLE_INSTEAD_TRIGGER                        -1126L
#define SQLE_INSTEAD_TRIGGER_POSITIONED             -1127L
#define SQLE_INVALID_TRIGGER_VIEW                   -1133L
#define SQLE_INVALID_TRIGGER_MATVIEW                -1134L
#define SQLE_MIRROR_FILE_MISMATCH                   -1138L
#define SQLE_CORRUPT_PAGE_READ_RETRY                143L
#define SQLE_MIRROR_FILE_REQUIRES_CHECKSUMS         144L
#define SQLE_ENCRYPTION_NOT_ENABLED                 -1143L
#define SQLE_ENCRYPTION_NOT_ENABLED_WARNING         140L
#define SQLE_INVALID_OPENSTRING_ENCODING            -1144L
#define SQLE_ENCRYPTION_TYPE_NOT_ACCEPTED           -1145L
#define SQLE_POSSIBLE_DATABASE_CORRUPTION           -1147L
#define SQLE_NOT_SUPPORTED_BY_CLIENT                -1148L
#define SQLE_DATABASE_ENDIAN_FAILURE                -1149L
#define SQLE_INVALID_SCRIPT_DLL                     -1150L
#define SQLE_INVALID_LOAD_LOGGING_TYPE              -1151L
#define SQLE_PASSWORD_EXPIRED                       -1152L
#define SQLE_PASSWORD_EXPIRED_READONLY_DB           -1153L
#define SQLE_INVALID_TRACED_PLAN                    -1154L
#define SQLE_CANNOT_LOAD_TEMP_WITH_CURSOR           -1155L
#define SQLE_TEXT_BAD_COLUMN_REFERENCE              -1156L
#define SQLE_TEXT_TOO_MANY_TABLE_REFERENCES         -1157L
#define SQLE_TEXT_NO_MATCHING_INDEX                 -1158L
#define SQLE_TEXT_QUERY_NOT_KNOWN                   -1159L
#define SQLE_TEXT_CONFIG_NOT_FOUND                  -1160L
#define SQLE_TEXT_CONFIG_ALREADY_EXISTS             -1161L
#define SQLE_TEXT_BAD_TERM_LENGTH                   -1162L
#define SQLE_TEXT_BAD_COLLATION                     -1163L
#define SQLE_TEXT_PARSER_ERROR                      -1164L
#define SQLE_TEXT_INDEX_CREATION_ERROR              -1165L
#define SQLE_TEXT_INDEX_SAME_SETTING_IDX            -1304L
#define SQLE_TEXT_INDEX_NO_PREFILTER                -1492L
#define SQLE_TEXT_INDEX_PREFILTER_NOT_ALLOWED       -1493L
#define SQLE_TEXT_INDEX_MIXED_COLUMNS               -1512L
#define SQLE_TEXT_INVALID_INDEX_FOR_PROC            -1526L
#define SQLE_TEXT_UPGRADE_REQUIRED                  -1166L
#define SQLE_TEXT_EXT_UPGRADE_REQUIRED              -1522L
#define SQLE_USER_OWNS_TEXT_CONFIG                  -1167L
#define SQLE_TEXT_CANNOT_ALTER_CONFIG               -1168L
#define SQLE_TEXT_CANNOT_USE_TEXT_INDEX             -1169L
#define SQLE_TEXT_BAD_OPTION                        -1174L
#define SQLE_TEXT_IMMEDIATE_NOT_ALLOWED             -1182L
#define SQLE_TEXT_INVALID_NEAR                      -1207L
#define SQLE_TEXT_QUERY_TOO_LONG                    -1370L
#define SQLE_TEXT_NEED_CONSTANT_ARGUMENT            -1216L
#define SQLE_TEXT_STOPLIST_TOO_LONG                 -1240L
#define SQLE_TEXT_STOPLIST_NULL                     -1389L
#define SQLE_TEXT_INVALID_STOPLIST_VALUE            -1391L
#define SQLE_TEXT_HANDLES_EXHAUSTED                 -1390L
#define SQLE_TEXT_MATCHING_INDEX_NOT_REFRESHED      -1253L
#define SQLE_TEXT_INVALID_VIEW_FOR_CONTAINS         -1283L
#define SQLE_TEXT_USER_SPECIFIED_ERROR              -1504L
#define SQLE_TEXT_NOT_ALLOWED_ACROSS_SERVERS        -1511L
#define SQLE_ERROR_INITIALIZING_EXT_PREFILTER       -1396L
#define SQLE_ERROR_INITIALIZING_EXT_TERMBREAKER     -1393L
#define SQLE_INVALID_EXT_PREFILTER_NAME             -1394L
#define SQLE_INVALID_EXT_TERMBREAKER_NAME           -1395L
#define SQLE_DB_ALIAS_RESERVED_UTILDB               -985L
#define SQLE_CLIENT_TRANSFER_NO_VALIDATION          -1171L
#define SQLE_CLIENT_TRANSFER_DISALLOWED             -1172L
#define SQLE_CLIENT_TRANSFER_ACCESS_ERROR           -1173L
#define SQLE_MIRROR_LOG_WITH_DB_MIRROR              -1178L
#define SQLE_UNABLE_TO_START_ENGINE_MISSING_LICENSE -1179L
#define SQLE_OPTION_ON_WATCH_LIST                   -1180L
#define SQLE_DBSPACE_PERMS_NOT_SUPPORTED            -1183L
#define SQLE_CORRUPT_ULTRALITE_INDEX                -1185L
#define SQLE_CORRUPT_ULTRALITE_DATABASE             -1186L
#define SQLE_UNLOAD_CANNOT_APPEND                   -1187L
#define SQLE_LOAD_TABLE_ERROR                       -1188L
#define SQLE_UTF16_ENDIAN_MISMATCH                  -1189L
#define SQLE_LOAD_TABLE_ON_MATVIEW_ERROR            -1190L
#define SQLE_LOAD_TABLE_WITH_IMV                    -1191L
#define SQLE_INVALID_LOAD_TABLE_OPTION              -1289L
#define SQLE_TRUNCATE_TABLE_WITH_IMV                -1193L
#define SQLE_LOGIN_POLICY_ALREADY_EXISTS            -1194L
#define SQLE_LOGIN_POLICY_NOT_FOUND                 -1195L
#define SQLE_LOGIN_POLICY_UPGRADE                   -1196L
#define SQLE_LOGIN_POLICY_IN_USE                    -1197L
#define SQLE_USER_ALREADY_EXISTS                    -1198L
#define SQLE_NO_MATCHING_INDEX                      -1226L
#define SQLE_CLIENT_TRANSFER_OPEN_ERROR             -1201L
#define SQLE_CLIENT_TRANSFER_PERMS_ERROR            -1200L
#define SQLE_UPDATE_ON_EXISTING_DEP_IMV             -1204L
#ifdef SAINT
#define SQLE_OLIN_AUTHORITIES_UNSUPPORTED           -1347L
#define SQLE_BAD_PARTITION_BOUND_VALUE              -1208L
#define SQLE_PARTITION_BOUND_VALUE_CONVERSION       -1209L
#define SQLE_PARTITION_BOUND_VALUE_ORDER            -1210L
#define SQLE_UNKNOWN_PARTITION_NAME                 -1239L
#define SQLE_CANNOT_USE_PARTITION_NAME              -1245L
#define SQLE_PARTITIONS_NOT_ADJACENT                -1246L
#define SQLE_UNKNOWN_LOGICALFILE_NAME               -1249L
#define SQLE_TABLE_NOT_PARTITIONED                  -1250L
#define SQLE_TABLE_PARTITIONED                      -1251L
#define SQLE_WRONG_DBSPACE_TYPE                     -1252L
#define SQLE_CANNOT_MERGE_COLUMN_PARTITION          -1255L
#define SQLE_CANNOT_CHANGE_PARTITION_KEY            -1284L
#define SQLE_INVALID_COL_PARTITION_PLACEMENT        -1291L
#define SQLE_INVALID_COL_PLACEMENT                  -1292L
#define SQLE_UNSUPPORTED_PARTITION_KEY              -1293L
#define SQLE_IN_DBSPACE_NOT_ALLOWED                 -1306L
#endif
#define SQLE_MERGE_CARDINALITY_VIOLATION            -1211L
#define SQLE_CONNECTION_DISALLOWED_BY_LOGIN_POLICY  -1212L
#define SQLE_EXTERNAL_LIBRARY_IN_USE                -1214L
#define SQLE_EXTERNAL_LIBRARY_NOT_LOADED            -1215L
#define SQLE_SYNC_PROFILE_NOT_FOUND                 -1217L
#define SQLE_SYNC_PROFILE_ALREADY_EXISTS            -1223L
#define SQLE_SYNC_PROFILE_INVALID                   -1224L
#define SQLE_SYNC_PROFILE_UPGRADE                   -1225L
#define SQLE_DUPLICATE_CREATE_DB_OPTION             -1221L
#define SQLE_TOO_MANY_CURSORS                       -1230L
#define SQLE_TOO_MANY_COLUMNS_IN_SELECT             -1235L
#define SQLE_TOO_MANY_COLUMNS_IN_GROUPBY            -1236L
#define SQLE_TOO_MANY_COLUMNS_IN_PROC_RES           -1237L
#ifdef SAINT
#define SQLE_IQ_MULTIPLEX_SERVER_NOT_FOUND          -1222L
#define SQLE_IQ_MPX_INTERNAL_ERROR                  -1227L
#define SQLE_IQ_ONLY_SYNTAX_ERROR                   -1228L
#define SQLE_IQ_DBSPACEFILE_UPDATE_ERROR            -1234L
#define SQLE_IQ_MULTIPLEX_ALTERTOSAMECONFIG         -1242L
#define SQLE_IQ_EVENT_TYPE_ALREADY_EXISTS           -1256L
#define SQLE_IQ_EVENT_MULTIPLE_CONDITIONS           -1257L
#define SQLE_IQ_EVENT_WRONG_OPERATOR                -1258L
#define SQLE_IQ_TRANSACTION_ROLLBACK                -1285L
#define SQLE_IQ_GTT_ALTER_DROP_NOTALLOWED           -1287L
#define SQLE_IQ_INVALID_HOSTNAME                    -1302L
#define SQLE_IQ_PARAM_LENGTH_EXCEED_LIMIT           -1294L
#define SQLE_IQ_MPX_ABS_DBPATH                      -1295L
#define SQLE_IQ_PARAM_VALUE_NOT_UNIQUE              -1296L
#define SQLE_IQ_MULTIPLEX_SERVER_LIMIT_EXCEEDED     -1297L
#define SQLE_IQ_INVALID_CONFIG_FAILOVER_COMBINATION -1298L
#define SQLE_IQ_DROP_MPX_ALLOWED_ONLY_IN_MPX        -1299L
#define SQLE_IQ_FIRST_SECONDARY_SERVER_CANNOT_BE_EXCLUDED -1300L
#define SQLE_IQ_CANNOT_CREATE_MPX_COORDINATOR       -1301L
#define SQLE_MPX_CONFIG_CHANGES_SRV_SHUTDOWN        -1317L
#define SQLE_EMSG_UDF_RAISED_ERROR                  -1320L
#endif
#define SQLE_PASSTHROUGH_SQL_SCRIPT_FAILED_W        141L
#define SQLE_PASSTHROUGH_SQL_SCRIPT_FAILED_E        -1238L
#define SQLE_REORG_ALREADY_IN_PROGRESS              -1229L
#define SQLE_STATEMENT_TIMEOUT                      -1231L
#define SQLE_HOLD_CURSOR_AFTER_TRUNCATE             -1241L
#define SQLE_ENCRYPT_DATABASE_FAILED                -1243L
#define SQLE_DECRYPT_DATABASE_FAILED                -1244L
#define SQLE_MERGE_USER_SPECIFIED_ERROR             -1254L
#define SQLE_HASH_ERROR                             -1259L
#define SQLE_DUPLICATE_ROW_FOUND_IN_DOWNLOAD        145L
#define SQLE_FEATURE_NOT_LICENSED                   -1260L
#define SQLE_CONNECTION_PROTOCOL_NOT_LICENSED       -1261L
#define SQLE_PLATFORM_NOT_LICENSED                  -1262L
#if defined ( SAINT )
#define SQLE_IQ_LICENSE_INITIALIZATION_FAILURE      -1513L
#define SQLE_IQ_CORE_LICENSE_CHECKOUT_FAILURE       -1514L
#endif
#define SQLE_EVENT_NOTIFICATION_QUEUE_FULL          146L
#define SQLE_EVENT_NOTIFICATIONS_LOST               147L
#define SQLE_EVENT_NOTIFICATION_QUEUE_NOT_FOUND_WARN 148L
#define SQLE_EVENT_NOTIFICATION_QUEUE_NOT_FOUND     -1263L
#define SQLE_INVALID_EVENT_OBJECT_NAME              -1264L
#define SQLE_EVENT_OBJECT_ALREADY_EXISTS            -1265L
#define SQLE_EVENT_NOTIFICATION_QUEUE_TIMEOUT       -1266L
#define SQLE_EVENT_PARAMETER_NOT_FOUND              -1267L
#define SQLE_NO_PERMS_FOR_IMV                       -1270L
#define SQLE_INCOMPLETE_SYNCHRONIZATION             -1271L
#define SQLE_SYNCHRONIZATION_IN_PROGRESS            -1272L
#define SQLE_TABLE_HAS_NO_COLUMNS                   -1273L
#define SQLE_INDEX_HAS_NO_COLUMNS                   -1274L
#define SQLE_INVALID_DOMAIN                         -1275L
#define SQLE_CONFIG_IN_USE                          -1276L
#define SQLE_PARAMETER_CANNOT_BE_NULL               -1277L
#define SQLE_ULTRALITEJ_OPERATION_NOT_ALLOWED       -1278L
#define SQLE_ULTRALITEJ_OPERATION_FAILED            -1279L
#define SQLE_UNDERFLOW                              -1280L
#define SQLE_ROW_LOCKED                             -1281L
#define SQLE_DATABASE_UPGRADE_WARNING               149L
#define SQLE_STMT_NOT_ALLOWED_WITH_MIRRORING        -1288L
#define SQLE_CURSOR_UPDATABILITY_CHANGED            -1290L
#define SQLE_CONNECTION_MESSAGE_QUEUE_FULL          -1303L
#define SQLE_SEQUENCES_NOT_SUPPORTED                -1369L
#define SQLE_UNIQUE_INDEX_NULLS_NOT_DISTINCT_NOT_SUPPORTED -1392L
#define SQLE_MIRRORING_OPTIONS_NOT_SUPPORTED        -1307L
#define SQLE_MIRROR_SERVER_NOT_FOUND                -1308L
#define SQLE_MIRROR_SERVER_ALREADY_EXISTS           -1309L
#define SQLE_MIRROR_SERVER_IN_USE                   -1310L
#define SQLE_MIRROR_PARTNERS_ALREADY_DEFINED        -1311L
#define SQLE_INVALID_MIRROR_PARENT                  -1312L
#define SQLE_MAX_STRING_LENGTH_EXCEEDED             -1313L
#define SQLE_CANNOT_FORCE_FAILOVER_ON_PREFERRED     -1314L
#define SQLE_SCRIPT_MISSING_DELIMITER               -1315L
#if defined ( SAINT )
#define SQLE_IQ_LOAD_TABLE_UNSUPPORTED_COLUMN_SPEC  -1316L
#endif
#define SQLE_TOO_MANY_ARTICLES_DELETED              -1318L
#define SQLE_SYNC_SCHEMA_UPGRADE                    -1319L
#define SQLE_INVALID_TABLE_TYPE                     -1321L
#define SQLE_SYNC_SCHEMA_IN_PROGRESS                -1322L
#define SQLE_SUBSCRIPTION_OMITTED                   -1323L
#define SQLE_CONNECTION_HAS_LOCKS                   -1324L
#define SQLE_COLUMN_SUBSET_MISMATCH                 -1325L
#define SQLE_SUBSCRIPTION_NAME_NOT_FOUND            -1326L
#define SQLE_TABLE_MUST_SYNCHRONIZE_IN_PUB          -1328L
#define SQLE_REQUIRES_SYNC_SCHEMA_CHANGE            -1329L
#define SQLE_FEATURE_UNKNOWN_OR_INVALID             -1332L
#define SQLE_FEATURE_NOT_LOCKED                     -1333L
#define SQLE_FEATURE_LOCKED                         -1334L
#define SQLE_FEATURE_LOCKED_SYNC                    -1343L
#define SQLE_METHOD_ON_NON_EXT                      -1335L
#define SQLE_METHOD_NOT_FOUND                       -1336L
#define SQLE_METHOD_NO_OVERLOAD                     -1337L
#define SQLE_METHOD_NO_CONSTRUCTOR                  -1338L
#define SQLE_METHOD_NO_OVERLOAD_N_ARGS              -1339L
#define SQLE_METHOD_NO_CONSTRUCTOR_N_ARGS           -1340L
#define SQLE_METHOD_NO_CONSTRUCTOR_OVERLOAD         -1341L
#define SQLE_SYNC_SCHEMA_CHANGE_DISALLOWS_DML       -1342L
#define SQLE_INVALID_CHILD_SERVER_NAME              -1348L
#define SQLE_PARENT_NOT_CONNECTED                   -1349L
#define SQLE_PARENT_NOT_PRIMARY                     -1350L
#define SQLE_CHILD_SERVER_CREATION_FAILED           -1351L
#define SQLE_MIRROR_SERVER_TYPE_ALREADY_DEFINED     -1352L
#define SQLE_CANNOT_ASSIGN_AUTO_PARENT              -1360L
#define SQLE_TREAT_AS_ONLY_EXTENDED                 -1361L
#define SQLE_TREAT_AS_DYNAMIC_MISMATCH              -1362L
#define SQLE_SYNCCMD_INTERNAL_ERROR                 -1373L
#define SQLE_SYNCCMD_SYNCH_FAILED                   -1374L
#define SQLE_SYNCCMD_START_SERVER_FAIL              -1375L
#define SQLE_SYNCCMD_CONNECT_SERVER_FAIL            -1376L
#define SQLE_SYNCCMD_TIMEOUT                        -1377L
#define SQLE_SYNCCMD_SHUTDOWN_FAIL                  -1378L
#define SQLE_SYNCCMD_SHUTDOWN_SLOW                  -1379L
#define SQLE_TOO_MANY_REDIRECTS                     -1380L
#define SQLE_MIRROR_SERVER_NAME_CONFLICT            -1381L
#define SQLE_INVALID_DOWNLOAD_VALUE                 -1382L
#define SQLE_MIRROR_COPY_SERVER_LIMIT_EXCEEDED      -1383L
#define SQLE_UNABLE_TO_STOP_DATABASE                -1384L
#define SQLE_MLA_SYNC_FAILED                        -1385L
#define SQLE_MLA_SYNC_CONNECT_SERVER_FAIL           -1386L
#define SQLE_MLA_SYNC_SHUTDOWN_FAIL                 -1387L
#define SQLE_MLA_SYNC_START_SERVER_FAIL             -1388L
#define SQLE_TEMP_TABLE_DEFINITION_CHANGED          -1397L
#define SQLE_LOAD_TABLE_DATA_FILE_ERROR             -1496L
#define SQLE_MOBILINK_AUTHENTICATION_FAILED         -1497L
#define SQLE_UNKNOWN_PROPERTY                       -1498L
#define SQLE_SLERR_INVALID_RELATE_MATRIX            -1399L
#define SQLE_SLERR_DUPLICATE_POINT                  -1400L
#define SQLE_SLERR_ELEMENT_IS_EMPTY                 -1401L
#define SQLE_SLERR_MIXED_SRS                        -1402L
#define SQLE_SLERR_COMPOUNDCURVE_NOT_CONTIGUOUS     -1403L
#define SQLE_SLERR_UNKNOWN_UOM                      -1404L
#define SQLE_SLERR_TRANSFORM_FAIL                   -1405L
#define SQLE_SLERR_TRANSFORM_POINT_FAIL             -1532L
#define SQLE_SLERR_WKT_PARSE_NEAR                   -1406L
#define SQLE_SLERR_WKB_PARSE                        -1407L
#define SQLE_SLERR_MIXED_DIM                        -1408L
#define SQLE_SLERR_SRID_UNKNOWN                     -1409L
#define SQLE_SLERR_CIRC_NUM_POINTS                  -1410L
#define SQLE_SLERR_CIRC_COLLINEAR_MIDPOINT          -1516L
#define SQLE_SLERR_ST_TO_XXX_FAILN                  -1411L
#define SQLE_SLERR_NEED_UPGRADE                     -1412L
#define SQLE_SLERR_NYI                              -1413L
#define SQLE_SLERR_WKT_PARSE_INCONSISTENT_ZM        -1414L
#define SQLE_SLERR_SERIAL_PARSE                     -1415L
#define SQLE_SLERR_WKB_PARSE_TYPE                   -1417L
#define SQLE_SLERR_WKB_PARSE_TYPE_NOT_PERMITTED     -1418L
#define SQLE_SLERR_WKB_PARSE_UNEXPECTED_EOF         -1419L
#define SQLE_SLERR_WKB_PARSE_INCONSISTENT_ZM        -1420L
#define SQLE_SLERR_WKB_PARSE_INVALID_BOM            -1421L
#define SQLE_SLERR_SHAPE_PARSE                      -1422L
#define SQLE_SLERR_SHAPE_PARSE_ATTRIBUTES           -1423L
#define SQLE_SLERR_SHAPE_INVALID_FILENAME           -1424L
#define SQLE_SLERR_SHAPE_MULTIPATCH                 -1425L
#define SQLE_SLERR_SRID_CONFLICT_EMBED_PARAM        -1426L
#define SQLE_SLERR_SRID_CONFLICT_EMBED_EMBED        -1427L
#define SQLE_SLERR_FMT_UNKNOWN                      -1428L
#define SQLE_SLERR_FMT_NOT_ALLOWED                  -1429L
#define SQLE_SLERR_WRONG_FORMAT                     -1430L
#define SQLE_SLERR_INVALID_FORMAT_SPECIFICATION     -1431L
#define SQLE_SLERR_INVALID_FORMAT_SPECIFICATION_OPTION -1432L
#define SQLE_SLERR_INVALID_FORMAT_SPECIFICATION_OPTION_VALUE -1433L
#define SQLE_SLERR_UNKOWNN_FORMAT                   -1434L
#define SQLE_SLERR_ROUND_EARTH_UNSUPPORTED          -1435L
#define SQLE_SLERR_ROUND_EARTH_UNSUPPORTED_DIS      -1436L
#define SQLE_SLERR_CONFIG_FILE_ERR                  -1438L
#define SQLE_SLERR_CONFIG_NO_SUBFILE                -1439L
#define SQLE_SLERR_COMPARISON_PREDICATE             -1440L
#define SQLE_SLERR_SRS_PARSE_ERROR                  -1441L
#define SQLE_SLERR_INVALID_TRANSFORM_DEF            -1442L
#define SQLE_SLERR_TRANSFORM_DEF_TOO_LONG           -1443L
#define SQLE_SLERR_NO_XFORM_DEF                     -1444L
#define SQLE_SLERR_NO_SRC_XFORM_DEF                 -1445L
#define SQLE_SLERR_UOM_NOT_LINEAR                   -1446L
#define SQLE_SLERR_UOM_NOT_ANGULAR                  -1447L
#define SQLE_SLERR_INVALID_POLY_ORD                 -1448L
#define SQLE_SLERR_INVALID_POLY_NO_EXT              -1449L
#define SQLE_SLERR_INVALID_POLY_NESTING             -1450L
#define SQLE_SLERR_INVALID_POLY_MULT_EXT            -1451L
#define SQLE_SLERR_UPDDEL_NO_PK                     -1452L
#define SQLE_SLERR_CREATE_INDEX_UNIQUE              -1453L
#define SQLE_SLERR_CREATE_INDEX_NOSRID              -1454L
#define SQLE_SLERR_DDL_UOM_NOFACT                   -1455L
#define SQLE_SLERR_DDL_SRS_AXISORDER                -1456L
#define SQLE_SLERR_DDL_SRS_COORDNAME                -1457L
#define SQLE_SLERR_DDL_NO_UOM                       -1458L
#define SQLE_SLERR_DDL_NO_SRS                       -1459L
#define SQLE_SLERR_DDL_UOM_EXISTS                   -1460L
#define SQLE_SLERR_DDL_SRS_EXISTS                   -1461L
#define SQLE_SLERR_DDL_SRS_NOSRID                   -1462L
#define SQLE_SLERR_DDL_SRS_BADWKT                   -1463L
#define SQLE_SLERR_DDL_SRS_BAD_SRS_TYPE             -1464L
#define SQLE_SLERR_DDL_SRS_NOELLIPSOID              -1465L
#define SQLE_SLERR_DDL_SRS_ELLIPSOID                -1466L
#define SQLE_SLERR_DDL_SRS_MUSTBOUND                -1467L
#define SQLE_SLERR_DDL_SRS_AXISORD                  -1468L
#define SQLE_SLERR_DDL_SRS_POLYFORMAT               -1469L
#define SQLE_SLERR_DDL_SRS_STGFORMAT                -1470L
#define SQLE_SLERR_DDL_SRS_INUSE                    -1471L
#define SQLE_SLERR_DDL_SRS_RESERVED                 -1472L
#define SQLE_SLERR_DDL_UOM_RESERVED                 -1473L
#define SQLE_SLERR_SRS_INUSE_TAB                    -1474L
#define SQLE_SLERR_SRS_INUSE_PROC                   -1475L
#define SQLE_SLERR_SRS_INUSE_TYPE                   -1476L
#define SQLE_SLERR_NOT_GEOGRAPHIC                   -1477L
#define SQLE_SLERR_SPATIAL_IN_BUILTIN               -1478L
#define SQLE_SLERR_NOT_UNION_COMPAT                 -1479L
#define SQLE_SLERR_INTERNAL_ERROR                   -1480L
#define SQLE_SLERR_NEARLY_ANTIPODAL                 -1482L
#define SQLE_SLERR_LINESTRING_MIN_POINTS            -1483L
#define SQLE_SLERR_OBJECT_OUT_OF_SRS_BOUNDS         -1484L
#define SQLE_SLERR_INVALID_POLY_RING_CLOSE          -1485L
#define SQLE_SLERR_INVALID_POLY_EMPTY_RING          -1486L
#define SQLE_SLERR_INVALID_POLY_NON_RING            -1487L
#define SQLE_SLERR_INVALID_POLY_RE_SIZE             -1488L
#define SQLE_SLWARN_INVALID_POSITION                -1489L
#define SQLE_SLWARN_POLYGON_RING_REORIENTED         -1490L
#define SQLE_SLWARN_CIRCULARSTRING_3POINT           -1491L
#define SQLE_SLERR_CIRCULAR_METHOD                  -1494L
#define SQLE_SLERR_CIRCULAR_SRS                     -1495L
#define SQLE_SLERR_INVALID_GRID_SIZE                -1499L
#define SQLE_SLERR_INVALID_TOLERANCE                -1500L
#define SQLE_SLERR_INVALID_BOUNDS                   -1501L
#define SQLE_SLERR_INVALID_MULTISURF_I              -1502L
#define SQLE_SLERR_GEOM_COLL_INTERSECT              -1503L
#define SQLE_SLERR_CPU_NEED_SSE                     -1515L
#define SQLE_SLERR_GEOM_ORDER_BY                    -1531L
#define SQLE_COPY_SERVER_NEEDS_PARENT               -1505L
#define SQLE_NO_TABLES_TO_SYNCHRONIZE               150L
#define SQLE_UNKNOWN_COLLATION                      -1506L
#define SQLE_SELECT_DML_OUTER_REFERENCE             -1529L
#endif
