/* *******************************************************************
 * Copyright 1988-2008 iAnywhere Solutions, Inc.  All rights reserved.
 * *******************************************************************/

#ifndef _SQLSTATE_H_INCLUDED
#define _SQLSTATE_H_INCLUDED
#define II_SQLSTATE

/**************************/
/* sql error return codes */
/**************************/

#define SQLSTATE_GENERIC_ERROR          SQLSTATE_ERROR

/*      Subtransaction Errors */

#define SQLSTATE_SUBTRANS_NOTFOUND                 "3B001"
#define SQLSTATE_SUBTRANS_REQUIRE_UNDO             "3BW01"



#define SQLSTATE_NOERROR                           "00000"
#define SQLSTATE_NOTFOUND                          "02000"
#define SQLSTATE_TRUNCATED                         "01004"
#define SQLSTATE_TEMPORARY_TABLE                   "01W02"
#define SQLSTATE_CANNOT_CONVERT                    "01W03"
#define SQLSTATE_ROW_DROPPED_DURING_SCHEMA_UPGRADE "01W21"
#define SQLSTATE_CANNOT_CONVERT_LOAD_TABLE         "01W01"
#define SQLSTATE_ROW_UPDATED_WARNING               "01W04"
#define SQLSTATE_PROCEDURE_COMPLETE                "01W05"
#define SQLSTATE_COLUMN_VALUE_CHANGED              "01W06"
#define SQLSTATE_CANNOT_EXECUTE_STMT               "01W08"
#define SQLSTATE_WARNING                           "01000"
#define SQLSTATE_UNABLE_TO_START_ENGINE            "08W07"
#define SQLSTATE_UNABLE_TO_START_ENGINE_FATAL_ERROR "08W89"
#define SQLSTATE_INVALID_COMMAND_LINE              "08W08"
#define SQLSTATE_DATABASE_NOT_ACTIVE               "08W30"
#define SQLSTATE_START_STOP_DATABASE_DENIED        "08W29"
#define SQLSTATE_REQUEST_DENIED_NO_DATABASES       "08W28"
#define SQLSTATE_ALIAS_CLASH                       "08W27"
#define SQLSTATE_INVALID_LOCAL_OPTION              "08W25"
#define SQLSTATE_UNABLE_TO_START_DATABASE          "08W09"
#define SQLSTATE_UNABLE_TO_START_DATABASE_VER_NEWER "08W67"
#define SQLSTATE_UNABLE_TO_START_DATABASE_LOG_ERROR "08W68"
#define SQLSTATE_DATABASE_NOT_FOUND                "08W10"
#define SQLSTATE_FILE_IN_USE                       "08W56"
#define SQLSTATE_INVALID_DATABASE                  "08W11"
#define SQLSTATE_DECRYPT_ERROR                     "08W63"
#define SQLSTATE_ENCRYPT_ERROR                     "08W66"
#define SQLSTATE_NO_DATABASE_FILE                  "08W39"
#define SQLSTATE_COMMUNICATIONS_ERROR              "08W12"
#define SQLSTATE_DYNAMIC_MEMORY_EXHAUSTED          "08W26"
#define SQLSTATE_CLIENT_OUT_OF_MEMORY              "08W65"
#define SQLSTATE_NO_MEMORY                         "08W13"
#define SQLSTATE_DATABASE_NAME_REQUIRED            "08W14"
#define SQLSTATE_PROTOCOL_MISMATCH                 "08W15"
#define SQLSTATE_TLS_HANDSHAKE_FAILED              "08W59"
#define SQLSTATE_TLS_INIT_FAILED_ON_SRV            "08W61"
#define SQLSTATE_ENGINE_ALREADY_RUNNING            "08W23"
#define SQLSTATE_ENGINE_NOT_MULTIUSER              "08W16"
#define SQLSTATE_ARGUMENT_CANNOT_BE_NULL           "WP000"
#define SQLSTATE_INVALID_PARSE_PARAMETER           "08W49"
#define SQLSTATE_INVALID_DSN_NAME                  "08W54"
#define SQLSTATE_INVALID_PARAMETER                 "08W24"
#define SQLSTATE_PAGE_SIZE_TOO_BIG                 "08W22"
#define SQLSTATE_PAGE_SIZE_TOO_SMALL               "54W03"
#define SQLSTATE_PAGE_SIZE_INVALID                 "08W32"
#define SQLSTATE_DATABASE_NOT_CREATED              "08W33"
#define SQLSTATE_AUTHENTICATION_VIOLATION          "08W21"
#define SQLSTATE_AUTHENTICATION_FAILED             "08W48"
#define SQLSTATE_CONNECTIONS_DISABLED              "08W04"
#define SQLSTATE_ENGINE_NOT_RUNNING                "08W01"
#define SQLSTATE_NOT_CONNECTED                     "08003"
#define SQLSTATE_TOO_MANY_CONNECTIONS              "08W03"
#define SQLSTATE_INVALID_LOGON                     "28000"
#define SQLSTATE_INVALID_MODULE_LOGON              "28W01"
#define SQLSTATE_PASSWORD_TOO_SHORT                "54W07"
#define SQLSTATE_UNABLE_TO_CONNECT                 "08001"
#define SQLSTATE_UNABLE_TO_CONNECT_OR_START        "08W55"
#define SQLSTATE_CANNOT_OPEN_LOG                   "08W05"
#define SQLSTATE_ERROR_WRITING_LOG                 "08W17"
#define SQLSTATE_CONNECTION_NOT_FOUND              "08W02"
#define SQLSTATE_STILL_ACTIVE_CONNECTIONS          "08W06"
#define SQLSTATE_NAME_NOT_UNIQUE                   "52010"
#define SQLSTATE_INDEX_NAME_NOT_UNIQUE             "52W04"
#define SQLSTATE_EXISTING_PRIMARY_KEY              "55013"
#define SQLSTATE_INVALID_FOREIGN_KEY_DEF           "53030"
#define SQLSTATE_INVALID_FOREIGN_KEY_ACTION        "42R01"
#define SQLSTATE_INVALID_FOREIGN_KEY_TABLE         "42R02"
#define SQLSTATE_INVALID_FOREIGN_KEY_INDEX         "42R03"
#define SQLSTATE_VIEW_DEFINITION_ERROR             "53011"
#define SQLSTATE_TABLE_MUST_BE_EMPTY               "55W02"
#define SQLSTATE_NO_PRIMARY_KEY                    "55008"
#define SQLSTATE_PRIMARY_KEY_COLUMN_DEFINED        "52009"
#define SQLSTATE_ALTER_CLAUSE_CONFLICT             "53W01"
#define SQLSTATE_PRIMARY_KEY_TWICE                 "52W05"
#define SQLSTATE_COLUMN_IN_INDEX                   "53W05"
#ifdef SAINT
#define SQLSTATE_USER_OWNS_TABLES                  "55W03"
#endif
#define SQLSTATE_IDENTIFIER_TOO_LONG               "54003"
#define SQLSTATE_DUPLICATE_FOREIGN_KEY             "52W06"
#define SQLSTATE_INDEX_NOT_FOUND                   "52W03"
#define SQLSTATE_MESSAGE_ALREADY_EXISTS            "52W16"
#define SQLSTATE_ALREADY_HAS_GRANT_PERMS           "42W01"
#define SQLSTATE_PERMISSION_DENIED                 "42501"
#define SQLSTATE_GROUP_CYCLE                       "42W02"
#define SQLSTATE_NOT_A_GROUP                       "42W03"
#define SQLSTATE_ALREADY_HAS_GROUP_MEMBERSHIP      "42W34"
#define SQLSTATE_INVALID_STATEMENT                 "07W02"
#define SQLSTATE_SYNTAX_ERROR                      "42W04"
#define SQLSTATE_STATEMENT_ERROR                   "26501"
#define SQLSTATE_INVALID_STATEMENT_TYPE            "07W03"
#define SQLSTATE_NOT_IMPLEMENTED                   "0A000"
#define SQLSTATE_TSQL_FEATURE_NOT_SUPPORTED        "0AW02"
#define SQLSTATE_LANGUAGE_EXTENSION                "0AW01"
#define SQLSTATE_STMT_NOT_ALLOWED_IN_PASSTHROUGH   "0AW05"
#define SQLSTATE_NOT_SUPPORTED_IN_ULTRALITE        "0AW07"
#define SQLSTATE_UNCOMMITTED_TRANSACTIONS          "0AW08"
#define SQLSTATE_UPLOAD_FAILED_AT_SERVER           "0AW09"
#define SQLSTATE_DOWNLOAD_CONFLICT                 "0AW11"
#define SQLSTATE_MOBILINK_COMMUNICATIONS_ERROR     "0AWD5"
#define SQLSTATE_CANNOT_CHANGE_USER_NAME           "0AW13"
#define SQLSTATE_SERVER_SYNCHRONIZATION_ERROR      "0AW12"
#define SQLSTATE_OMNI_FEATURE_NOT_SUPPORTED        "0AW18"
#define SQLSTATE_DBSPACE_NOT_FOUND                 "52W13"
#define SQLSTATE_DEFAULT_DBSPACE_NOT_FOUND         "52W43"
#define SQLSTATE_CORRELATION_NAME_AMBIGUOUS        "52012"
#define SQLSTATE_UNKNOWN_USERID                    "08004"
#define SQLSTATE_TABLE_NOT_FOUND                   "42W33"
#define SQLSTATE_CORRELATION_NAME_NOT_FOUND        "52W02"
#define SQLSTATE_INVALID_CORRELATION_FOR_ROWID     "42WBF"
#define SQLSTATE_INVALID_ROWID_PLACEMENT           "42WC1"
#define SQLSTATE_COLUMN_NOT_FOUND                  "52003"
#define SQLSTATE_COLUMN_NOT_FOUND_IN_TABLE         "52005"
#define SQLSTATE_COLUMN_AMBIGUOUS                  "52002"
#define SQLSTATE_FOREIGN_KEY_NAME_NOT_FOUND        "52W07"
#define SQLSTATE_CANNOT_JOIN                       "53W04"
#define SQLSTATE_AMBIGUOUS_JOIN                    "52W08"
#define SQLSTATE_OUTER_JOIN_CYCLE                  "52W14"
#define SQLSTATE_CORRELATION_NAME_NEEDED           "52W15"
#define SQLSTATE_UNKNOWN_FUNC                      "42W05"
#define SQLSTATE_INVALID_GROUP_SELECT              "53003"
#define SQLSTATE_NO_CONSTANTS_IN_GROUP_BY          "42W9D"
#define SQLSTATE_INVALID_GROUPING_AGGREGATE        "42WA7"
#define SQLSTATE_TOO_MANY_GROUPING_EXPRESSIONS     "42WA1"
#define SQLSTATE_AGGREGATES_NOT_ALLOWED            "42W06"
#define SQLSTATE_SUBQUERY_SELECT_LIST              "53023"
#define SQLSTATE_INVALID_ORDER                     "53005"
#define SQLSTATE_INVALID_UNION                     "53026"
#define SQLSTATE_MESSAGE_NOT_FOUND                 "52W17"
#define SQLSTATE_USER_TYPE_NOT_FOUND               "52W18"
#define SQLSTATE_SEQUENCE_NOT_FOUND                "52W44"
#define SQLSTATE_INVALID_SEQUENCE_OPERATION        "52W46"
#define SQLSTATE_SEQUENCE_CURRVAL_NOT_DEFINED      "52W51"
#define SQLSTATE_SEQUENCE_ALREADY_EXISTS           "52W47"
#define SQLSTATE_SEQUENCE_EXHAUSTED                "52W48"
#define SQLSTATE_INVALID_SEQUENCE_DEFINITION       "52W49"
#define SQLSTATE_DUPLICATE_SEQUENCE_OPTION         "52W50"
#define SQLSTATE_INVALID_ALTER_SEQUENCE            "52W54"
#define SQLSTATE_USER_OWNS_MESSAGES_OR_DATATYPES   "55W05"
#define SQLSTATE_USER_OWNS_REPLICATED_OBJECTS      "55W06"
#define SQLSTATE_WRONG_PARAMETER_COUNT             "37505"
#define SQLSTATE_INVALID_PARAMETER_NAME            "42W47"
#define SQLSTATE_VARIABLE_INVALID                  "42W07"
#define SQLSTATE_EXPRESSION_ERROR                  "42W08"
#define SQLSTATE_CONVERSION_ERROR                  "53018"
#define SQLSTATE_CONVERSION_ERROR_LOAD_TABLE       "53017"
#define SQLSTATE_OVERFLOW_ERROR                    "22003"
#define SQLSTATE_INVALID_COLUMN_NUMBER             "42W13"
#define SQLSTATE_DESCRIBE_NONSELECT                "07005"
#define SQLSTATE_INVALID_DESCRIBE_TYPE             "07W01"
#define SQLSTATE_CURSOR_NOT_DECLARED               "24W01"
#define SQLSTATE_OPEN_CURSOR_ERROR                 "07003"
#define SQLSTATE_CURSOR_ALREADY_OPEN               "24502"
#define SQLSTATE_CURSOR_NOT_OPEN                   "24501"
#define SQLSTATE_CURSOR_INVALID_STATE              "24000"
#define SQLSTATE_NO_INDICATOR                      "22002"
#define SQLSTATE_SQLDA_TOO_SMALL                   "07002"
#define SQLSTATE_TOO_MANY_RECORDS                  "21000"
#define SQLSTATE_SUBQUERY_RESULT_NOT_UNIQUE        "21W01"
#define SQLSTATE_CURSOROP_NOT_ALLOWED              "09W02"
#define SQLSTATE_NOT_ENOUGH_HOST_VARS              "07001"
#define SQLSTATE_NOT_FOUND_IN_INDEX                "WI005"
#define SQLSTATE_NON_UPDATEABLE_COLUMN             "53W02"
#define SQLSTATE_CANNOT_MODIFY                     "42W32"
#define SQLSTATE_NON_UPDATEABLE_VIEW               "42W31"
#define SQLSTATE_PRIMARY_KEY_NOT_UNIQUE            "23W01"
#define SQLSTATE_INVALID_FOREIGN_KEY               "23503"
#define SQLSTATE_COLUMN_CANNOT_BE_NULL             "23502"
#define SQLSTATE_COLUMN_CANNOT_BE_NULL_LOAD_TABLE  "23501"
#define SQLSTATE_INDEX_NOT_UNIQUE                  "23505"
#define SQLSTATE_NO_CURRENT_ROW                    "24503"
#define SQLSTATE_PRIMARY_KEY_VALUE_REF             "23W05"
#define SQLSTATE_ONLY_ONE_TABLE                    "09W04"
#define SQLSTATE_INVALID_COLUMN_VALUE              "23506"
#define SQLSTATE_ROW_UPDATED_SINCE_READ            "22W02"
#define SQLSTATE_WRONG_NUM_OF_INSERT_COLS          "53002"
#define SQLSTATE_VARIABLE_NOT_FOUND                "42W14"
#define SQLSTATE_VARIABLE_EXISTS                   "42W15"
#define SQLSTATE_LABEL_NOT_FOUND                   "42W24"
#define SQLSTATE_INVALID_FETCH_POSITION            "42W25"
#define SQLSTATE_WRONG_NUM_OF_FETCH_VARIABLES      "42W26"
#define SQLSTATE_PROCEDURE_NOT_FOUND               "52W09"
#define SQLSTATE_ATOMIC_OPERATION                  "42W28"
#define SQLSTATE_TRIGGER_NOT_FOUND                 "52W10"
#define SQLSTATE_COLUMN_IN_TRIGGER                 "53W06"
#ifdef SAINT
#define SQLSTATE_USER_OWNS_PROCEDURES              "55W04"
#endif
#define SQLSTATE_USER_OWNS_PROCEDURES_IN_USE       "42W55"
#define SQLSTATE_USER_OWNS_SEQUENCES_IN_USE        "42WE2"
#define SQLSTATE_USER_OWNS_TABLES_IN_USE           "42W56"
#define SQLSTATE_TRIGGER_DEFN_CONFLICT             "52W11"
#define SQLSTATE_INVALID_TRIGGER_COL_REFS          "52W12"
#define SQLSTATE_INVALID_TRIGGER_STATEMENT         "2D501"
#define SQLSTATE_NESTING_TOO_DEEP                  "42W29"
#define SQLSTATE_PUBLICATION_NOT_FOUND             "5RW01"
#define SQLSTATE_TABLE_HAS_PUBLICATIONS            "5RW02"
#define SQLSTATE_SUBSCRIPTION_NOT_UNIQUE           "5RW03"
#define SQLSTATE_SUBSCRIPTION_NOT_FOUND            "5RW04"
#define SQLSTATE_ONLY_ONE_PUBLISHER                "5RW05"
#define SQLSTATE_NOT_REMOTE_USER                   "5RW06"
#define SQLSTATE_NOT_REMOTE_TYPE                   "5RW07"
#define SQLSTATE_PASSTHROUGH_INCONSISTENT          "5RW08"
#define SQLSTATE_REMOTE_STATEMENT_FAILED           "5RW09"
#define SQLSTATE_CONSOLIDATED_USER_ALREADY_EXISTS  "5RW10"
#define SQLSTATE_SYNCHRONIZATION_NOT_FOUND         "5RW12"
#define SQLSTATE_SYNC_SITE_NOT_FOUND               "5RW37"
#define SQLSTATE_CANNOT_SUBSCRIBE                  "5RW13"
#define SQLSTATE_CANNOT_MODIFY_SYNC_AS_PUB         "5RW14"
#define SQLSTATE_CANNOT_MODIFY_PUB_AS_SYNC         "5RW15"
#define SQLSTATE_CANNOT_SYNC_TABLE_WITHOUT_PK      "5RW16"
#define SQLSTATE_PK_NOT_IN_SYNC_ARTICLE            "5RW17"
#define SQLSTATE_BLOB_IN_SYNC_TABLE_PK             "5RW18"
#define SQLSTATE_ARTICLE_PK_CANNOT_BE_UPDATED      "5RW19"
#define SQLSTATE_SAME_EXCLUSIVE_APP_RUNNING        "5RW21"
#define SQLSTATE_SAME_APP_RUNNING                  "5RW22"
#define SQLSTATE_CANNOT_REG_CONN                   "5RW23"
#define SQLSTATE_DEREG_APP_NOT_FOUND               "5RW24"
#define SQLSTATE_DEREG_APP_IN_USE                  "5RW25"
#define SQLSTATE_CONN_ALREADY_REGISTERED           "5RW26"
#define SQLSTATE_NOT_UNIQUE_CONN_REG_LABEL         "5RW27"
#define SQLSTATE_APP_REG_COOKIE_EXHAUSTED          "5RW28"
#define SQLSTATE_CONN_REG_AUTO_LABEL_EXHAUSTED     "5RW29"
#define SQLSTATE_BAD_SYNC_OPTION_VALUE             "5RW32"
#define SQLSTATE_SYNC_OPTION_NOT_FOUND             "5RW33"
#define SQLSTATE_SYNC_OPTION_TOO_LONG              "5RW34"
#define SQLSTATE_SYNC_CONTAINS_TABLE               "5RW35"
#define SQLSTATE_TABLE_ALREADY_INCLUDED            "5RW36"
#define SQLSTATE_CONFLICTING_PUB_TYPE              "5RW38"
#define SQLSTATE_CANNOT_UNIQUELY_IDENTIFY_ROWS     "09W05"
#define SQLSTATE_ERROR_NUMBER_OUT_OF_RANGE         "53W07"
#define SQLSTATE_INVALID_FORMAT_STRING_ARG_NUM     "53W08"
#define SQLSTATE_INVALID_OPTION                    "42W16"
#define SQLSTATE_INVALID_OPTION_SETTING            "42W17"
#define SQLSTATE_LOCKED                            "42W18"
#define SQLSTATE_MUST_BE_ONLY_CONNECTION           "42W19"
#define SQLSTATE_CHECKPOINT_REQUIRES_UNDO          "42W20"
#define SQLSTATE_TABLE_IN_USE                      "42W21"
#define SQLSTATE_PROCEDURE_IN_USE                  "42W23"
#define SQLSTATE_SEQUENCE_IN_USE                   "42WE3"
#define SQLSTATE_LOCK_TIMEOUT                      "42WC4"
#define SQLSTATE_SAVEPOINT_NOTFOUND                "3B001"
#define SQLSTATE_ROLLBACK_NOT_ALLOWED              "3B002"
#define SQLSTATE_RESULT_NOT_ALLOWED                "3BW02"
#define SQLSTATE_SAVEPOINTS_REQUIRE_UNDO           "3BW01"
#define SQLSTATE_PP_DBLIB_MISMATCH                 "08W18"
#define SQLSTATE_DBLIB_ENGINE_MISMATCH             "08W19"
#define SQLSTATE_UNKNOWN_BACKUP_OPERATION          "WB001"
#define SQLSTATE_BACKUP_NOT_STARTED                "WB002"
#define SQLSTATE_BACKUP_CANNOT_RENAME_LOG_YET      "WB003"
#define SQLSTATE_BACKUP_UNABLE_TO_DELETE_FILE      "WB004"
#define SQLSTATE_LOG_TRUNCATED                     "WB005"
#define SQLSTATE_USER_DEFINED_EXCEPTION            "99999"
#define SQLSTATE_DOUBLE_REQUEST                    "42W22"
#define SQLSTATE_INTERRUPTED                       "57014"
#define SQLSTATE_ERROR                             "40000"
#define SQLSTATE_DATABASE_ERROR                    "40W01"
#define SQLSTATE_TERMINATED_BY_USER                "40W02"
#define SQLSTATE_DISK_WRITE_FAILED                 "40W05"
#define SQLSTATE_DEVICE_FULL                       "40W03"
#define SQLSTATE_DEVICE_ERROR                      "40W04"
#define SQLSTATE_DEADLOCK                          "40001"
#define SQLSTATE_THREAD_DEADLOCK                   "40W06"
#define SQLSTATE_CONNECTION_TERMINATED             "40W07"
#define SQLSTATE_MEMORY_ERROR                      "40W08"
#define SQLSTATE_LOG_CORRUPTED                     "WI004"
#define SQLSTATE_UNSUPPORTED_LOAD_FORMAT           "WL001"
#define SQLSTATE_UNSUPPORTED_UNLOAD_FORMAT         "WL018"
#define SQLSTATE_CANNOT_ACCESS_FILE                "WL002"
#define SQLSTATE_CANNOT_UNLOAD_A_VIEW              "WL004"
#define SQLSTATE_DBSPACE_FULL                      "04W07"
#define SQLSTATE_ACCESS_BEYOND_END_OF_MAX_DBSPACE  "04W08"
#define SQLSTATE_PATTERN_TOO_LONG                  "WW001"
#define SQLSTATE_CANNOT_STOP_SERVER                "WW002"
#define SQLSTATE_INVALID_TEXTPTR_VALUE             "22W03"
#define SQLSTATE_INVALID_TEXT_IMAGE_DATATYPE       "53W09"
#define SQLSTATE_WRITETEXT_TABLE_WITH_IMV          "55W32"
#define SQLSTATE_TOO_MANY_COLUMNS_IN_TABLE         "52W20"
#define SQLSTATE_EXTERNAL_CALLS_NOT_SUPPORTED      "WW003"
#define SQLSTATE_EXTERNAL_PLATFORM_FAILURE         "WW004"
#define SQLSTATE_REQUIRE_DLL_NAME                  "WW005"
#define SQLSTATE_COULD_NOT_LOAD_LIBRARY            "WW006"
#define SQLSTATE_COULD_NOT_FIND_FUNCTION           "WW007"
#define SQLSTATE_ERROR_CALLING_FUNCTION            "WW008"
#define SQLSTATE_DDL_NOT_ALLOWED_IN_PROCEDURES     "52W21"
#define SQLSTATE_DATATYPE_NOT_ALLOWED              "WW009"
#define SQLSTATE_TOO_MANY_PARAMETERS               "WW010"
#define SQLSTATE_THREAD_START_FAILURE              "WW011"
#define SQLSTATE_INVALID_SYNTAX_EXTENSION          "0AW03"
#define SQLSTATE_DIV_ZERO_ERROR                    "22012"
#define SQLSTATE_INVALID_ESCAPE_CHAR               "22019"
#define SQLSTATE_INVALID_ESCAPE_SEQ                "22025"
#define SQLSTATE_INVALID_REGULAR_EXPRESSION        "2201B"
#define SQLSTATE_INVALID_USE_OF_ESCAPE_CHARACTER   "2200C"
#define SQLSTATE_ESCAPE_CHARACTER_CONFLICT         "2200B"
#define SQLSTATE_RAISERROR_STMT                    "WW012"
#define SQLSTATE_WITH_CHECK_OPTION_VIOLATION       "44000"
#define SQLSTATE_READ_ONLY_CURSOR                  "42W30"
#define SQLSTATE_UNTERMINATED_C_STR                "22024"
#define SQLSTATE_SYNTAX_EXTENSION_WARNING          "01W07"
#define SQLSTATE_NO_COLUMN_PERMS_FOR_VIEWS         "52W22"
#define SQLSTATE_NULL_VALUE_ELIMINATED             "01003"
#define SQLSTATE_DUPLICATE_REFERENCING_COLUMN      "42W40"
#define SQLSTATE_DUPLICATE_INSERT_COLUMN           "42W41"
#define SQLSTATE_STRING_RIGHT_TRUNCATION           "22001"
#define SQLSTATE_PARAMETER_NAME_MISSING            "42W42"
#define SQLSTATE_INVALID_DESCRIPTOR_INDEX          "07009"
#define SQLSTATE_ERROR_IN_ASSIGNMENT               "22005"
#define SQLSTATE_INVALID_DESCRIPTOR_NAME           "33000"
#define SQLSTATE_BACKUP_PAGE_INCOMPLETE            "01W10"
#define SQLSTATE_NOT_PUBLIC_ID                     "42W43"
#define SQLSTATE_MORE_INFO                         "01W09"
#define SQLSTATE_TOO_MANY_COLUMNS_DELETED          "42W44"
#define SQLSTATE_TEMPORARY_NOT_ALLOWED             "42W45"
#define SQLSTATE_INVALID_OPTION_ON_CONNECT         "01W11"
#define SQLSTATE_OPTION_REQUIRES_DBA               "42W46"
#define SQLSTATE_OPTION_IS_TEMP_ONLY               "42W52"
#define SQLSTATE_OPTION_IN_PROCEDURE               "42W53"
#define SQLSTATE_INVALID_STANDARD_LOGON            "28W02"
#define SQLSTATE_INVALID_INTEGRATED_LOGON          "28W03"
#define SQLSTATE_LOGON_MODE_NOT_PERMITTED          "28W14"
#define SQLSTATE_INTEGRATED_LOGON_FAILED           "28W04"
#define SQLSTATE_INTEGRATED_LOGON_TOO_MANY_MAPPINGS "28W10"
#define SQLSTATE_KERBEROS_LOGON_FAILED             "28W12"
#define SQLSTATE_KERBEROS_LOGONS_UNSUPPORTED       "28W13"
#define SQLSTATE_PREEMPTED                         "WI006"
#define SQLSTATE_RETRY                             "WI008"
#define SQLSTATE_INTEGRATED_LOGON_UNSUPPORTED      "28W05"
#define SQLSTATE_INTEGRATED_LOGON_GUESTMAP         "28W06"
#define SQLSTATE_LOGON_SYSMAP                      "28W07"
#define SQLSTATE_LOGON_MAPPED                      "28W08"
#define SQLSTATE_LOGON_UNMAPPED                    "28W09"
#define SQLSTATE_STORE_NOT_LOADED                  "08W34"
#define SQLSTATE_STORE_ENTRY_NOT_FOUND             "08W35"
#define SQLSTATE_STORE_VERSION_MISMATCH            "08W47"
#define SQLSTATE_INVALID_DBSPACE_FOR_CREATE        "08W36"
#define SQLSTATE_FIELD_NOT_FOUND                   "WW013"
#define SQLSTATE_CHECKSUMS_NOT_ENABLED             "WW042"
#define SQLSTATE_INVALID_INDEX_TYPE                "WW016"
#define SQLSTATE_DROP_DATABASE_FAILED              "WW017"
#define SQLSTATE_NO_PROFILE_FILE                   "08W37"
#define SQLSTATE_GEN_PARSE_ERROR                   "08W38"
#define SQLSTATE_DATABASE_ACTIVE                   "08W40"
#define SQLSTATE_DATABASE_NEEDS_RECOVERY           "08W41"
#define SQLSTATE_NO_SCROLL_CURSOR                  "09W06"
#define SQLSTATE_METHOD_CANNOT_BE_CALLED           "WJ001"
#define SQLSTATE_DATABASE_UPGRADE_FAILED           "08W42"
#define SQLSTATE_DATABASE_UPGRADE_NOT_POSSIBLE     "08W43"
#define SQLSTATE_DBO_DOES_NOT_OWN_ROWGENERATOR     "08W57"
#define SQLSTATE_USER_TABLES_IN_SYSTEM_RANGE       "08W58"
#define SQLSTATE_INVALID_CURSOR_RANGE              "09W07"
#define SQLSTATE_INVALID_TRANSACTION_ISOLATION     "WJ003"
#define SQLSTATE_NO_COLUMN_NAME                    "52004"
#define SQLSTATE_TABLE_HAS_REFACTION               "56001"
#define SQLSTATE_AMBIGUOUS_INDEX_NAME              "52W40"
#define SQLSTATE_INVALID_TSQL_OJ_EXPRESSION        "52W23"
#define SQLSTATE_INVALID_TSQL_JOIN_TYPE            "52W24"
#define SQLSTATE_DUPLICATE_CURSOR_NAME             "WJ004"
#define SQLSTATE_ROLLBACK_ON_PREFETCH              "WW019"
#define SQLSTATE_BLOCKING_OTHERS_ROLLBACK          "WW148"
#define SQLSTATE_RESOURCE_GOVERNOR_EXCEEDED        "WP009"
#define SQLSTATE_BAD_PARAM_INDEX                   "WJ005"
#define SQLSTATE_BACKUP_NOT_LOADED                 "08W44"
#define SQLSTATE_BACKUP_ENTRY_NOT_FOUND            "08W45"
#define SQLSTATE_BACKUP_ERROR                      "08W46"
#define SQLSTATE_SQLDA_INCONSISTENT                "07W04"
#define SQLSTATE_SQLDA_INVALID_DATATYPE            "07W05"
#define SQLSTATE_INVALID_SQL_IDENTIFIER            "07W06"
#define SQLSTATE_CANNOT_TRUNCATE_VIEW              "42W49"
#define SQLSTATE_COMPUTED_COLUMN_WRITE_ATTEMPTED   "WW023"
#define SQLSTATE_TEXT_OPERATION_ON_VIEW            "42W50"
#define SQLSTATE_COMPUTED_COLUMNS_NOT_SUPPORTED    "0AW06"
#define SQLSTATE_CAPABILITY_NOT_FOUND              "WO014"
#define SQLSTATE_RENAME_WITH_VERIFY_NOT_ALLOWED    "42WE5"
#define SQLSTATE_RESTORE_INCONSISTENT              "WB006"
#define SQLSTATE_RESTORE_INVALID_FORMAT            "WB007"
#define SQLSTATE_RESTORE_UNABLE_TO_OPEN            "WB008"
#define SQLSTATE_RESTORE_UNABLE_TO_WRITE           "WB009"
#define SQLSTATE_RESTORE_UNABLE_TO_START           "WB010"
#define SQLSTATE_CANNOT_VALIDATE_OBJECT            "42W51"
#define SQLSTATE_CANNOT_OPTIMIZE_QUERY             "WI010"
#define SQLSTATE_CANNOT_PERFORM_CHAR_TRANSLATION   "01W12"
#define SQLSTATE_UNSUPPORTED_CHARACTER_SET_ERROR   "08W64"
#define SQLSTATE_UNSUPPORTED_CHARACTER_SET_WARNING "01W13"
#define SQLSTATE_UNSUPPORTED_LANGUAGE              "01W14"
#define SQLSTATE_UNSUPPORTED_CHARSET_AND_LANGUAGE  "01W15"

#if !defined( UNDER_CE )

#define SQLSTATE_OMNI_CONNECT_ERROR                "WO001"
#define SQLSTATE_OMNI_CIRCULAR_CONNECT             "WO002"
#define SQLSTATE_OMNI_READONLY                     "WO003"
#define SQLSTATE_OMNI_SERVER_NOT_FOUND             "WO004"
#define SQLSTATE_OMNI_REMOTE_ERROR                 "WO005"
#define SQLSTATE_OMNI_BACKWARDS_CURSOR             "WO006"
#define SQLSTATE_OMNI_RMT_TABLE_NOTFOUND           "WO007"
#define SQLSTATE_OMNI_RMT_COLUMNS_NOTFOUND         "WO008"
#endif

#define SQLSTATE_OMNI_DEBUG                        "WO010"

#if !defined( UNDER_CE )

#define SQLSTATE_OMNI_AUTOINC_NOT_SUPPORTED        "WO011"
#define SQLSTATE_OMNI_SERVER_NOT_CAPABLE           "WO012"
#define SQLSTATE_OMNI_EXTLOGIN_NOT_FOUND           "WO013"
#define SQLSTATE_USER_HAS_EXTERNLOGINS             "WO028"
#define SQLSTATE_OMNI_DATATYPE_MISMATCH            "WO015"
#define SQLSTATE_OMNI_NOSUCH_COLUMN                "WO016"
#define SQLSTATE_OMNI_LENGTH_MISMATCH              "WO017"
#define SQLSTATE_OMNI_NULL_MISMATCH                "WO018"
#define SQLSTATE_OMNI_IDENTITY_MISMATCH            "WO019"
#define SQLSTATE_OMNI_RMT_TABLE_NOTUNIQUE          "WO020"
#define SQLSTATE_OMNI_COMPUTED_NOT_SUPPORTED       "WO021"
#define SQLSTATE_OMNI_UNSUPPORTED_DATATYPE         "WO022"
#define SQLSTATE_OMNI_EXPRESSION_IN_PROC           "WO023"
#define SQLSTATE_OMNI_FILE_SYSTEM_ERROR            "WO027"

#endif

#if !defined( UNDER_CE )

#define SQLSTATE_IQ_PATH_SYNTAX_ERROR              "42W48"

#define SQLSTATE_IQ_LOG_REQUIRED                   "0AQ48"

#endif

#if !defined( NO_EXTENV )

#define SQLSTATE_UNHANDLED_EXTENV_EXCEPTION        "WP001"
#define SQLSTATE_BAD_CLASS_FILE                    "WP002"
#define SQLSTATE_BAD_JAR_FILE                      "WP010"
#define SQLSTATE_INVALID_FIELD_REFERENCE           "WW014"
#define SQLSTATE_NAMESPACE_HEAP_EXHAUSTED          "WP007"
#define SQLSTATE_JAVA_VM_HEAP_EXHAUSTED            "WP008"
#define SQLSTATE_FIELD_CANNOT_BE_NULL              "WW015"
#define SQLSTATE_CANNOT_DECOMPRESS_CLASS           "WP003"
#define SQLSTATE_CLASS_MEMBER_OF_JAR               "WP004"
#define SQLSTATE_JAVA_SERIALIZATION_ERROR          "WI009"
#define SQLSTATE_JAVA_DESERIALIZATION_ERROR        "WW018"
#define SQLSTATE_BAD_CLASS_BYTE_CODE               "WP005"
#define SQLSTATE_EXTENV_NOT_STARTED                "WP006"
#define SQLSTATE_CANNOT_INDEX_ON_JAVA_CLASS        "WW022"
#define SQLSTATE_PROCEDURE_RETURNS_VOID            "53019"
#define SQLSTATE_INVALID_COMPARISON                "52W25"
#define SQLSTATE_EXTERN_ENV_NOT_FOUND              "WJ030"
#define SQLSTATE_EXTERN_ENV_UPGRADE                "WW104"
#define SQLSTATE_EXTERN_ENV_NO_RESULT_SET_SUPPORT  "WJ031"

#endif

#define SQLSTATE_NON_UPDATEABLE_EXT_TAB            "42W35"
#define SQLSTATE_UNENFORCEABLE_FOREIGN_KEY         "23507"
#define SQLSTATE_TOO_MANY_NULL_COLUMNS             "23504"
#define SQLSTATE_CANNOT_UPDATE_NULL_ROW            "09W08"
#define SQLSTATE_CANNOT_UPDATE_TWO_TABLES_IMV      "55W29"
#define SQLSTATE_INVALID_USER_ESTIMATE             "01W16"
#define SQLSTATE_SIGNATURE_MISMATCH                "42W54"
#define SQLSTATE_UNKNOWN_OPTION                    "01W17"
#define SQLSTATE_DB_INIT_NOT_CALLED                "55W07"
#define SQLSTATE_FAILED_TO_CREATE_STREAMS_ENV      "WW024"
#define SQLSTATE_IQ_INVALID_COMMAND_LINE           "08W51"
#define SQLSTATE_IQ_MEMORY_MANAGER_FAILED          "08W52"
#define SQLSTATE_IQ_SYSTEM_V_FAILURE               "08W53"
#define SQLSTATE_READ_ONLY_DATABASE                "55W08"
#define SQLSTATE_NOT_SYNC_TYPE                     "5RW11"
#define SQLSTATE_UNABLE_TO_OPEN_BACKUP_LOG         "WB011"
#define SQLSTATE_VIEW_OVER_TEMP_OBJECT             "42U00"
#define SQLSTATE_EVENT_NOT_FOUND                   "WE001"
#define SQLSTATE_EVENT_ALREADY_EXISTS              "WE002"
#define SQLSTATE_SCHEDULE_NOT_FOUND                "WE003"
#define SQLSTATE_SCHEDULE_ALREADY_EXISTS           "WE004"
#define SQLSTATE_INVALID_EVENT_DAY                 "WE005"
#define SQLSTATE_INVALID_EVENT_TIME                "WE006"
#define SQLSTATE_INVALID_EVENT_START               "WE007"
#define SQLSTATE_EVENT_START_TIME_IN_PAST          "WE010"
#define SQLSTATE_MAX_ROW_SIZE_EXCEEDED             "WW089"
#define SQLSTATE_DTC_TRANSACTIONS_NOT_SUPPORTED    "0AW10"
#define SQLSTATE_CANNOT_COMMIT_OR_ROLLBACK_WHILE_ENLISTED "55W09"
#define SQLSTATE_CANNOT_ENLIST_WHILE_ALREADY_ENLISTED "55W10"
#define SQLSTATE_CANNOT_ENLIST_WITH_UNCOMMITTED_DATA "55W11"
#define SQLSTATE_FAILED_TO_ENLIST                  "WL005"
#define SQLSTATE_FAILED_TO_REENLIST                "WL006"
#define SQLSTATE_EVENT_TYPE_NOT_FOUND              "WE008"
#define SQLSTATE_HOSTVARS_IN_BATCH                 "07W07"
#define SQLSTATE_TEST_HARNESS                      "WW025"
#define SQLSTATE_EXTENV_OBJECT_NOT_FOUND           "42W57"
#define SQLSTATE_JAR_NOT_FOUND                     "42W58"
#define SQLSTATE_NO_MATCHING_SELECT_ITEM           "42W59"
#define SQLSTATE_NON_UPDATEABLE_CURSOR             "42W36"
#define SQLSTATE_CANNOT_UPDATE_ORDER_BY_COLUMN     "42W37"
#define SQLSTATE_UPDATE_NOT_IN_SELECT              "42W38"
#define SQLSTATE_TOO_MANY_TEMP_TABLES              "52W41"
#define SQLSTATE_INCOMPATIBLE_EXTERNAL_CALL        "WW026"
#define SQLSTATE_INVALID_POSITION                  "24504"
#define SQLSTATE_DBSPACE_FOR_TABLE_UNAVAILABLE     "52W19"
#define SQLSTATE_INVALID_CORRELATION_NAME_REFERENCE "42U01"
#define SQLSTATE_PREVIOUS_ERROR_LOST               "WP011"
#define SQLSTATE_RECORDING_CONFLICT_DETECTED       "WW027"
#define SQLSTATE_ALIAS_NOT_UNIQUE                  "42W60"
#define SQLSTATE_ALIAS_NOT_YET_DEFINED             "42W61"
#define SQLSTATE_CONNECTION_ERROR                  "08W60"
#define SQLSTATE_ROW_REMODIFIED_OR_DELETED         "42W62"
#define SQLSTATE_EVENT_IN_USE                      "WE009"
#define SQLSTATE_PROCEDURE_NO_LONGER_VALID         "42W63"
#define SQLSTATE_TRIGGER_NO_LONGER_VALID           "42W64"
#define SQLSTATE_BAD_ENCRYPTION_KEY                "08W62"
#define SQLSTATE_INVALID_COLUMN_QUALIFICATION      "42U02"
#define SQLSTATE_INVALID_SET_CLAUSE                "42U03"
#define SQLSTATE_AMBIGUOUS_TABLE_NAME              "52W42"
#define SQLSTATE_AMBIGUOUS_SEQUENCE_NAME           "52W45"
#define SQLSTATE_INVALID_ORDERBY_COLUMN            "42W65"
#define SQLSTATE_CURSOR_OPTIONS_CHANGED            "01S02"
#define SQLSTATE_AMBIGUOUS_TRIGGER_NAME            "42W66"
#define SQLSTATE_INVALID_SQLLEN                    "07W08"
#define SQLSTATE_HISTOGRAMS_NOT_SUPPORTED_ON_OBJECT "42W67"
#define SQLSTATE_DBSPACE_NOT_CALIBRATED            "WW028"
#define SQLSTATE_MULTIPLE_AGGREGATE_COLUMNS        "42W68"
#define SQLSTATE_INVALID_AGGREGATE_PLACEMENT       "42W69"
#define SQLSTATE_INVALID_DISTINCT_AGGREGATE        "42W70"
#define SQLSTATE_INVALID_NUMBER                    "42W71"
#define SQLSTATE_BAD_RESULT_SET                    "WP012"
#define SQLSTATE_UNKNOWN_CHARSET                   "WC001"
#define SQLSTATE_INVALID_ENCODING_FOR_COLLATION    "WC009"
#define SQLSTATE_INVALID_NCHAR_COLLATION           "WC010"
#define SQLSTATE_FAILED_TO_START_CONVERTER         "WC002"
#define SQLSTATE_FAILED_TO_START_CONVERTER_2_CHARSETS "WC008"
#define SQLSTATE_COLLATION_NOT_SUPPORTED           "WC013"
#define SQLSTATE_CHAR_COLLATION_NOT_SUPPORTED      "WC015"
#define SQLSTATE_NCHAR_COLLATION_NOT_SUPPORTED     "WC016"
#define SQLSTATE_ICU_NOT_AVAILABLE                 "WC012"
#define SQLSTATE_TOO_MANY_RESULT_SETS              "WP013"
#define SQLSTATE_NO_RESULT_SET                     "WP014"
#define SQLSTATE_JAVA_VM_INSUFFICIENT_CACHE        "WP015"
#define SQLSTATE_NO_XML_IDENTIFIER                 "WX001"
#define SQLSTATE_CANNOT_JOIN_TABEXPR               "42W73"
#define SQLSTATE_NONDETERMINISTIC_RESULT           "01W18"
#define SQLSTATE_SETUSER_NOT_IN_PROCEDURES         "42W09"
#define SQLSTATE_CLUSTERED_INDEX_NOT_ALLOWED       "42W74"
#define SQLSTATE_ILLEGAL_MULTIBYTE_ERROR           "WC003"
#define SQLSTATE_ILLEGAL_MULTIBYTE_WARNING         "01WC1"
#define SQLSTATE_SIMPLE_SUBSTITUTION_ERROR         "WC005"
#define SQLSTATE_SIMPLE_SUBSTITUTION_WARNING       "01WC3"
#define SQLSTATE_COLLATION_DEFAULT_WARNING         "01WC4"
#define SQLSTATE_FAILED_TO_CONVERT_CHARSET         "WC011"
#define SQLSTATE_CHARACTER_CONVERSION_REPORT_NOT_AVAILABLE "WC007"
#define SQLSTATE_TOO_MANY_VIRTUAL_INDEX_COLUMNS    "54W50"
#define SQLSTATE_USING_VIRTUAL_INDEXES             "01W20"
#define SQLSTATE_XML_PARSER_ERROR                  "WX002"
#define SQLSTATE_XQUERY_PARSER_ERROR               "WX003"
#define SQLSTATE_NONDETERMINISTIC_FUNCTION         "42W79"
#define SQLSTATE_SYNTACTIC_LIMIT                   "54W01"
#define SQLSTATE_BAD_OPENXML_FLAG                  "WX004"
#define SQLSTATE_STMT_NOT_ALLOWED_IN_PLAN          "0AW14"
#define SQLSTATE_STMT_NOT_ALLOWED_FOR_NOEXEC_PLAN  "0AW20"
#define SQLSTATE_HTML_PLAN_NOT_SUPPORTED           "0AW21"
#define SQLSTATE_UNSET_PUBLIC_ID                   "42W82"
#define SQLSTATE_CANNOT_DUMP_STRING_HISTOGRAM      "01W23"
#define SQLSTATE_BAD_FOR_XML_EXPLICIT_TAG          "WX005"
#define SQLSTATE_BAD_FOR_XML_EXPLICIT_DIRECTIVE    "WX006"
#define SQLSTATE_BAD_FOR_XML_EXPLICIT_COLUMN_NAME  "WX007"
#define SQLSTATE_EXPLICIT_TAG_NOT_OPEN             "WX008"
#define SQLSTATE_UNDECLARED_FOR_XML_EXPLICIT_TAG   "WX009"
#define SQLSTATE_FOR_XML_EXPLICIT_TOO_FEW_COLUMNS  "WX010"
#define SQLSTATE_FOR_XML_EXPLICIT_NAMED_CDATA      "WX011"
#define SQLSTATE_INVALID_ORDERBY_IN_AGGREGATE      "42W90"
#define SQLSTATE_INVALID_XQUERY_CONSTRUCTOR        "WX012"
#define SQLSTATE_XMLGEN_EVALUATION_FAILURE         "WX013"
#define SQLSTATE_NO_SQLX_ARGUMENT_NAME             "WX014"
#define SQLSTATE_ULTRALITE_OBJ_CLOSED              "55W14"
#define SQLSTATE_SYSTEM_COMMAND_FAILED             "38W01"
#define SQLSTATE_CONTROL_CHARACTER_IN_XML_OUTPUT   "WX015"
#define SQLSTATE_XQUERY_MEMORY_ERROR               "WX016"
#define SQLSTATE_AUDITING_WITHOUT_TRANSACTION_LOG  "42W91"
#define SQLSTATE_COMMON_TABLE_EXPRESSION_CYCLE     "42W93"
#define SQLSTATE_SERVICE_TYPE_REQUIRED             "42W92"
#define SQLSTATE_UNKNOWN_SERVICE_TYPE              "42W94"
#define SQLSTATE_SERVICE_IN_USE                    "55W15"
#define SQLSTATE_SERVICE_REQUIRES_USER_NAME        "42W96"
#define SQLSTATE_SERVICE_ALREADY_EXISTS            "42W97"
#define SQLSTATE_SERVICE_NOT_FOUND                 "42W98"
#define SQLSTATE_INVALID_RECURSION                 "42W99"
#define SQLSTATE_NO_RECURSIVE_COLUMN_LIST          "42W9A"
#define SQLSTATE_RECURSIVE_KEYWORD_REQUIRED        "42WA0"
#define SQLSTATE_BAD_RECURSIVE_COLUMN_CONVERSION   "42WA2"
#define SQLSTATE_TOO_MANY_RECURSIVE_ITERATIONS     "57015"
#define SQLSTATE_INVALID_SERVICE_NAME              "42W95"
#define SQLSTATE_HOSTVAR_MUST_BE_NAMED             "42W9B"
#define SQLSTATE_SERVICE_STATEMENT_MISMATCH        "42W9C"
#define SQLSTATE_SERVICE_STATEMENT_INVALID         "42WCC"
#define SQLSTATE_CONSTRAINT_NOT_FOUND              "42U04"
#define SQLSTATE_AMBIGUOUS_CONSTRAINT              "42U05"
#define SQLSTATE_SERVICE_AUTH_REQUIRED             "42W9E"
#define SQLSTATE_SERVICE_ATTR_NOT_ALLOWED          "42WB2"
#define SQLSTATE_SERVICE_ATTR_COEXIST              "42WB1"
#define SQLSTATE_SERVICE_PARM_INVALID_VALUE        "42WAD"
#define SQLSTATE_SERVICE_PARM_MISSING_VALUE        "42WAE"
#define SQLSTATE_SERVICE_PARM_UNSUPPORTED_PROPERTY "42WAF"
#define SQLSTATE_SERVICE_PARM_DUPLICATE_PROPERTY   "42WB0"
#define SQLSTATE_TOO_MANY_CONSTRAINTS              "54W02"
#define SQLSTATE_INVALID_CONSTRAINT_REF            "42U06"
#define SQLSTATE_INVALID_HINT                      "42U07"
#define SQLSTATE_INVALID_HTTP_OPTION_SETTING       "42W83"
#define SQLSTATE_INVALID_HTTP_HEADER_SETTING       "42W84"
#define SQLSTATE_INVALID_SOAP_HEADER_SETTING       "42W86"
#define SQLSTATE_NO_ENCRYPTION_FOR_JCONNECT        "08W69"
#define SQLSTATE_WORKLOAD_CAPTURE_ALREADY_EXISTS   "WW029"
#define SQLSTATE_WORKLOAD_CAPTURE_DOES_NOT_EXIST   "WW030"
#define SQLSTATE_RESULT_SET_NOT_PERMITTED          "09W03"
#define SQLSTATE_WINDOW_NOT_FOUND                  "42WA3"
#define SQLSTATE_PARTITIONBY_NOT_ALLOWED           "42WA4"
#define SQLSTATE_ORDERBY_NOT_ALLOWED               "42WA5"
#define SQLSTATE_FRAME_NOT_ALLOWED                 "42WA6"
#define SQLSTATE_FUNCTION_DOES_NOT_ALLOW           "42WE0"
#define SQLSTATE_FUNCTION_REQUIRES                 "42WE1"
#define SQLSTATE_CANNOT_ACCESS_SCHEMA_FILE         "WW031"
#define SQLSTATE_SYNC_STATUS_UNKNOWN               "WW032"
#define SQLSTATE_SCHEMA_UPGRADE_NOT_ALLOWED        "WW033"
#define SQLSTATE_ULTRALITE_DATABASE_NOT_FOUND      "WW034"
#define SQLSTATE_CONNECTION_ALREADY_EXISTS         "WW035"
#define SQLSTATE_SYNC_INFO_INVALID                 "WW036"
#define SQLSTATE_INVALID_FRAME_BOUNDARY            "22X13"
#define SQLSTATE_PASSWORD_TOO_LONG                 "54W08"
#define SQLSTATE_COMPRESSION_ERROR                 "WW037"
#define SQLSTATE_DECOMPRESSION_ERROR               "WW038"
#define SQLSTATE_BASE64_DECODING_ERROR             "WW039"
#define SQLSTATE_ILLEGAL_PASSWORD                  "08005"
#define SQLSTATE_ILLEGAL_WINDOW_PREDICATE          "42WA8"
#define SQLSTATE_OBSOLETE_ORDERBY_REQUIRED         "42WA9"
#define SQLSTATE_ILLEGAL_COMPOSITE_ORDERBY         "42WAA"
#define SQLSTATE_BACKUP_FILE_EXISTS                "WB012"
#define SQLSTATE_BACKUP_UNABLE_TO_OPEN_FILE        "WB017"
#define SQLSTATE_ALREADY_HAS_EXEC_PERMS            "42WAB"
#define SQLSTATE_REQUIRED_OPERATORS_EXCLUDED       "WI011"
#define SQLSTATE_CONNECTION_RESTORED               "WW040"
#define SQLSTATE_CURSOR_RESTORED                   "WW041"
#define SQLSTATE_DATABASE_STATE_RESTORED           "WW114"
#define SQLSTATE_STRING_PARM_TOO_LONG              "54W06"
#define SQLSTATE_DEVICE_IO_FAILED                  "WW043"
#define SQLSTATE_INCORRECT_VOLUME_ID               "WW044"
#define SQLSTATE_MISSING_ENCRYPTION_DLL            "08W70"
#define SQLSTATE_DIRECTORY_INACCESSIBLE            "WW047"
#define SQLSTATE_CANNOT_WRITE_FILE                 "WW048"
#define SQLSTATE_INVALID_URI                       "WW049"
#define SQLSTATE_UNABLE_TO_CONNECT_TO_HOST         "WW050"
#define SQLSTATE_REMOTE_CONNECTION_TIMED_OUT       "WW051"
#define SQLSTATE_HTTP_REQUEST_FAILED               "WW052"
#define SQLSTATE_ENCRYPTION_INITIALIZATION_FAILED  "WW053"
#define SQLSTATE_INVALID_PROCEDURE_TYPE            "WW055"
#define SQLSTATE_INVALID_PROCEDURE_SUBTYPE         "WW056"
#define SQLSTATE_INVALID_HTTP_RESPONSE             "WW057"
#define SQLSTATE_INVALID_NAMESPACE_ATTRIBUTE       "WW058"
#define SQLSTATE_SECURE_CONNECTION_FAILED          "WW059"
#define SQLSTATE_INVALID_PROCEDURE_ATTRIBUTE       "WW060"
#define SQLSTATE_HTTP_HEADER_ATTRIBUTE_RESERVED_XXX "WW070"
#define SQLSTATE_HTTP_HEADER_ATTRIBUTE_ASCII       "WW071"
#define SQLSTATE_HTTP_HEADER_ATTRIBUTE_MALFORMED   "WW072"
#define SQLSTATE_INVALID_ATTRIBUTE_MISMATCH_BRACES "WW086"
#define SQLSTATE_INVALID_ATTRIBUTE_MISSING_COMMA   "WW087"
#define SQLSTATE_INVALID_ATTRIBUTE_OPTIONS         "WW088"
#define SQLSTATE_CANNOT_REGISTER_LISTENER          "54W04"
#define SQLSTATE_INVALID_TEMP_TABLE_COMMIT_ACTION  "WL007"
#define SQLSTATE_INVALID_LOAD_TABLE_WITH_FOREIGN_KEY "WL009"
#define SQLSTATE_TOO_MANY_ARGUMENTS                "42WAC"
#define SQLSTATE_SELECT_INTO_WARNING_TREATED_AS_ERROR "WP016"
#define SQLSTATE_LOCAL_CONNECTION_NOT_FOUND        "WO024"
#define SQLSTATE_LOCAL_CONNECTION_NOT_TO_CURRENT_DB "WO025"
#define SQLSTATE_CANNOT_CLOSE_JDBC_CONNECTION      "WO026"
#define SQLSTATE_DATABASE_CREATED                  "WW061"
#define SQLSTATE_INVALID_REQUEST_LOG_FORMAT        "WW020"
#define SQLSTATE_TEMP_SPACE_LIMIT                  "54W05"
#define SQLSTATE_NO_DEFAULT_FOR_PARM               "08W71"
#define SQLSTATE_UNRECOGNIZED_OPTION               "WW062"
#define SQLSTATE_FILE_NOT_DB                       "08W85"
#define SQLSTATE_FILE_WRONG_VERSION                "08W86"
#define SQLSTATE_FILE_BAD_DB                       "08W87"
#define SQLSTATE_CORRUPT_REDO                      "08W88"
#define SQLSTATE_CORRUPT_REDO_MIRROR               "08W72"
#define SQLSTATE_CORRUPT_REDO_OR_MIRROR            "08W73"
#define SQLSTATE_EXPECTING_NO_REDO                 "08W74"
#define SQLSTATE_UNKNOWN_ENCRYPTION_ALGORITHM      "08W75"
#define SQLSTATE_UPGRADE_DATABASE                  "08W76"
#define SQLSTATE_LOG_NEWER_THAN_DB                 "08W80"
#define SQLSTATE_LOG_NOT_FOUND                     "08W81"
#define SQLSTATE_LOG_OFFSETS_DONT_MATCH            "08W82"
#define SQLSTATE_LOG_OLDER_THAN_DB                 "08W83"
#define SQLSTATE_LOG_TOO_SHORT                     "08W84"
#define SQLSTATE_INVALID_BACKUP_OPERATION          "WB013"
#define SQLSTATE_INVALID_BACKUP_PARM_VALUE         "WB015"
#define SQLSTATE_INVALID_BACKUP_STATEMENT          "WB016"
#define SQLSTATE_ROW_DELETED_TO_MAINTAIN_REFERENTIAL_INTEGRITY "01W24"
#define SQLSTATE_BACKUP_HAS_UNCOMMITTED_TRANS      "WB014"
#define SQLSTATE_MAT_VIEWS_NOT_SUPPORTED           "0AW15"
#define SQLSTATE_SECURE_CONNECTION_UNAVAILABLE     "WW063"
#define SQLSTATE_MATVIEW_SYNTAX_ERROR              "42WB3"
#define SQLSTATE_UPDATABLE_MATVIEW_SYNTAX_ERROR    "42WB4"
#define SQLSTATE_UPDATABLE_MATVIEW_PSNS_ON_CONDITION "42WE4"
#define SQLSTATE_UPDATABLE_MATVIEW_OUTERREFERENCE_ON_CONDITION "42WE7"
#define SQLSTATE_UPDATABLE_MATVIEW_ISNOTNULL       "42WE8"
#define SQLSTATE_UPDATABLE_MATVIEW_PK              "42WE9"
#define SQLSTATE_UPDATABLE_MATVIEW_MISSING_COUNT   "42WC6"
#define SQLSTATE_UPDATABLE_MATVIEW_MULTIBLE_BLOCK_ERR "42WC5"
#define SQLSTATE_UPDATABLE_MATVIEW_ERR             "42WCB"
#define SQLSTATE_DELETE_UPDATABLE_MATVIEW_INDEX_ERR "55W21"
#define SQLSTATE_UPDATABLE_MATVIEW_NON_AGGR_INDEX  "42WC7"
#define SQLSTATE_INVALID_OPERATION_FOR_TBL_WITH_IMV "55W31"
#define SQLSTATE_MAINTENANCE_OF_IMV_FAILED         "42WC8"
#define SQLSTATE_UPDATABLE_MATVIEW_SUM_NULL_EXPR   "42WCD"
#define SQLSTATE_UPDATABLE_MATVIEW_COUNT_NULL_EXPR "42WCE"
#define SQLSTATE_INVALID_ATTRIBUTE_WITH_TYPE       "WW064"
#define SQLSTATE_LOAD_TABLE_ON_MIRRORED_DB         "WL008"
#define SQLSTATE_WRONG_DB_ON_ALT_SERVER_NAME       "08W90"
#define SQLSTATE_OBJECT_HAS_DEPENDENTS             "55W16"
#define SQLSTATE_VIEW_DISABLED                     "55W17"
#define SQLSTATE_CONNECTED_TO_MIRROR_SERVER        "08W91"
#define SQLSTATE_VIEW_INVALID                      "55W18"
#define SQLSTATE_MATVIEW_NOT_FOUND                 "42WB5"
#define SQLSTATE_COMMENT_NOT_ALLOWED               "WW065"
#define SQLSTATE_REQUEST_TIMEOUT                   "57W01"
#define SQLSTATE_INVALID_NEW_PASSWORD              "28W11"
#define SQLSTATE_ILLEGAL_COLUMN_DEFINITION         "55W19"
#define SQLSTATE_ENCRYPTED_TABLES_NOT_SUPPORTED    "55W20"
#define SQLSTATE_VALUE_IS_NULL                     "22030"
#define SQLSTATE_CANNOT_CREATE_MATVIEW             "42WB6"
#define SQLSTATE_CANNOT_UPDATE_MATVIEW             "42WB7"
#define SQLSTATE_IMMEDIATE_MV_REFRESH_NOT_ALLOWED  "42WC3"
#define SQLSTATE_IMMEDIATE_MV_NO_UNIQUE_INDEX      "42WCA"
#define SQLSTATE_INVALID_OPTION_VALUE              "42W85"
#define SQLSTATE_SNAPSHOT_ISOLATION_DISABLED       "55W23"
#define SQLSTATE_SNAPSHOT_TABLE_CHANGED            "42WB8"
#define SQLSTATE_STATEMENT_NOT_ALLOWED_IN_SNAPSHOT "42WB9"
#define SQLSTATE_AUDITING_DB_READ_ONLY             "08W93"
#define SQLSTATE_SNAPSHOT_UPDATE_CONFLICT          "42WBA"
#define SQLSTATE_NON_SNAPSHOT_TRANSACTION          "42WBB"
#define SQLSTATE_SNAPSHOT_ALREADY_STARTED          "42WC9"
#define SQLSTATE_FIPS_NOT_AVAILABLE                "0AW16"
#define SQLSTATE_CANNOT_USE_MATVIEW                "42WBC"
#define SQLSTATE_COMPUTED_COLUMN_CYCLE             "42WBD"
#define SQLSTATE_MUST_NOT_BE_REPLICATING           "42WBE"
#define SQLSTATE_NO_TRACING_LEVELS                 "55W24"
#define SQLSTATE_INVALID_TRACING_SPEC              "WW066"
#define SQLSTATE_TRACING_OBJ_NOT_FOUND             "WW067"
#define SQLSTATE_NO_VOLATILE_LEVEL_SPEC            "WW068"
#define SQLSTATE_NO_LOCAL_CONNECTIONS_TO_ENCRYPTED "WW069"
#define SQLSTATE_SECURE_FEATURE                    "57W02"
#define SQLSTATE_SECURE_STATEMENT                  "57W04"
#define SQLSTATE_DUPLICATE_KEY_COLUMN              "42WC0"
#define SQLSTATE_ULTRALITE_WRITE_ACCESS_DENIED     "42Z00"
#define SQLSTATE_INVALID_SHARED_COMMIT_ACTION      "52W26"
#define SQLSTATE_INVALID_PARAMETER_W_PARM          "08W94"
#define SQLSTATE_TABLE_CONSTRAINT_VIOLATED         "23508"
#define SQLSTATE_PUBLICATION_PREDICATE_IGNORED     "01W25"
#define SQLSTATE_FEATURE_NOT_ENABLED               "0A001"
#define SQLSTATE_CHAR_FIELD_SIZE_EXCEEDED          "54W09"
#define SQLSTATE_ATTACH_TRACING_FAILED             "08W95"
#define SQLSTATE_TRACING_ALREADY_ATTACHED          "08W96"
#define SQLSTATE_TCP_CONNECTIONS_NOT_ENABLED       "08WA3"
#define SQLSTATE_TSQL_OUTER_JOINS_DISABLED         "55W25"
#define SQLSTATE_DUPLICATE_OPTION                  "01W26"
#define SQLSTATE_COLUMN_NOT_STREAMABLE             "WW045"
#define SQLSTATE_COLUMN_NOT_INDEXED                "WW073"
#define SQLSTATE_DOWNLOAD_RESTART_FAILED           "WW074"
#define SQLSTATE_PARTIAL_DOWNLOAD_NOT_FOUND        "WW075"
#define SQLSTATE_TOO_MANY_USERS                    "54W10"
#define SQLSTATE_TOO_MANY_PUBLICATIONS             "WW077"
#define SQLSTATE_TOO_MANY_BLOB_REFS                "54W11"
#define SQLSTATE_CANNOT_ACCESS_FILESYSTEM          "WW078"
#define SQLSTATE_KEYLESS_ENCRYPTION                "WW079"
#define SQLSTATE_SYNC_NOT_REENTRANT                "WW080"
#define SQLSTATE_SYNC_INFO_REQUIRED                "WW081"
#define SQLSTATE_FILE_VOLUME_NOT_FOUND             "WW082"
#define SQLSTATE_ROW_EXCEEDS_PAGE_SIZE             "WW083"
#define SQLSTATE_CANNOT_CHANGE_ML_REMOTE_ID        "0AW17"
#define SQLSTATE_UNSUPPORTED_PROPERTY              "42WC2"
#define SQLSTATE_DBSPACE_CONTAINS_TABLES           "55W26"
#define SQLSTATE_NO_ROOM_TO_GROW_DBSPACE           "57W03"
#define SQLSTATE_INVALID_MAXIMUM_PARAMETERS        "WW084"
#define SQLSTATE_INVALID_MIMETYPE                  "WW085"
#define SQLSTATE_ICU_DLL_VERSION_MISMATCH          "WC014"
#define SQLSTATE_CHECK_TRIGGER_CONFLICT            "42W39"
#define SQLSTATE_INSTEAD_TRIGGER                   "42W3A"
#define SQLSTATE_INSTEAD_TRIGGER_POSITIONED        "42W3B"
#define SQLSTATE_INVALID_TRIGGER_VIEW              "42W3C"
#define SQLSTATE_INVALID_TRIGGER_MATVIEW           "42W3D"
#define SQLSTATE_MIRROR_FILE_MISMATCH              "WW090"
#define SQLSTATE_CORRUPT_PAGE_READ_RETRY           "WW115"
#define SQLSTATE_MIRROR_FILE_REQUIRES_CHECKSUMS    "WW116"
#define SQLSTATE_ENCRYPTION_NOT_ENABLED            "55W27"
#define SQLSTATE_ENCRYPTION_NOT_ENABLED_WARNING    "01005"
#define SQLSTATE_INVALID_OPENSTRING_ENCODING       "WC017"
#define SQLSTATE_ENCRYPTION_TYPE_NOT_ACCEPTED      "08W97"
#define SQLSTATE_POSSIBLE_DATABASE_CORRUPTION      "08W98"
#define SQLSTATE_NOT_SUPPORTED_BY_CLIENT           "0AW19"
#define SQLSTATE_DATABASE_ENDIAN_FAILURE           "08W99"
#define SQLSTATE_INVALID_SCRIPT_DLL                "WW091"
#define SQLSTATE_INVALID_LOAD_LOGGING_TYPE         "WL010"
#define SQLSTATE_PASSWORD_EXPIRED                  "08WA0"
#define SQLSTATE_PASSWORD_EXPIRED_READONLY_DB      "08WA1"
#define SQLSTATE_INVALID_TRACED_PLAN               "55W28"
#define SQLSTATE_CANNOT_LOAD_TEMP_WITH_CURSOR      "WL011"
#define SQLSTATE_TEXT_BAD_COLUMN_REFERENCE         "WT001"
#define SQLSTATE_TEXT_TOO_MANY_TABLE_REFERENCES    "WT002"
#define SQLSTATE_TEXT_NO_MATCHING_INDEX            "WT003"
#define SQLSTATE_TEXT_QUERY_NOT_KNOWN              "WT004"
#define SQLSTATE_TEXT_CONFIG_NOT_FOUND             "WT005"
#define SQLSTATE_TEXT_CONFIG_ALREADY_EXISTS        "WT006"
#define SQLSTATE_TEXT_BAD_TERM_LENGTH              "WT007"
#define SQLSTATE_TEXT_BAD_COLLATION                "WT008"
#define SQLSTATE_TEXT_PARSER_ERROR                 "WT009"
#define SQLSTATE_TEXT_INDEX_CREATION_ERROR         "WT010"
#define SQLSTATE_TEXT_INDEX_SAME_SETTING_IDX       "WT021"
#define SQLSTATE_TEXT_INDEX_NO_PREFILTER           "WT030"
#define SQLSTATE_TEXT_INDEX_PREFILTER_NOT_ALLOWED  "WT031"
#define SQLSTATE_TEXT_INDEX_MIXED_COLUMNS          "WT034"
#define SQLSTATE_TEXT_INVALID_INDEX_FOR_PROC       "WT036"
#define SQLSTATE_TEXT_UPGRADE_REQUIRED             "WT011"
#define SQLSTATE_TEXT_EXT_UPGRADE_REQUIRED         "WT035"
#define SQLSTATE_USER_OWNS_TEXT_CONFIG             "55W12"
#define SQLSTATE_TEXT_CANNOT_ALTER_CONFIG          "WT012"
#define SQLSTATE_TEXT_CANNOT_USE_TEXT_INDEX        "WT013"
#define SQLSTATE_TEXT_BAD_OPTION                   "WT014"
#define SQLSTATE_TEXT_IMMEDIATE_NOT_ALLOWED        "WT015"
#define SQLSTATE_TEXT_INVALID_NEAR                 "WT016"
#define SQLSTATE_TEXT_QUERY_TOO_LONG               "WT022"
#define SQLSTATE_TEXT_NEED_CONSTANT_ARGUMENT       "WT017"
#define SQLSTATE_TEXT_STOPLIST_TOO_LONG            "WT018"
#define SQLSTATE_TEXT_STOPLIST_NULL                "WT023"
#define SQLSTATE_TEXT_INVALID_STOPLIST_VALUE       "WT025"
#define SQLSTATE_TEXT_HANDLES_EXHAUSTED            "WT024"
#define SQLSTATE_TEXT_MATCHING_INDEX_NOT_REFRESHED "WT019"
#define SQLSTATE_TEXT_INVALID_VIEW_FOR_CONTAINS    "WT020"
#define SQLSTATE_TEXT_USER_SPECIFIED_ERROR         "WT032"
#define SQLSTATE_TEXT_NOT_ALLOWED_ACROSS_SERVERS   "WT033"
#define SQLSTATE_ERROR_INITIALIZING_EXT_PREFILTER  "WT027"
#define SQLSTATE_ERROR_INITIALIZING_EXT_TERMBREAKER "WT028"
#define SQLSTATE_INVALID_EXT_PREFILTER_NAME        "WT029"
#define SQLSTATE_INVALID_EXT_TERMBREAKER_NAME      "WT026"
#define SQLSTATE_DB_ALIAS_RESERVED_UTILDB          "08W20"
#define SQLSTATE_CLIENT_TRANSFER_NO_VALIDATION     "WW092"
#define SQLSTATE_CLIENT_TRANSFER_DISALLOWED        "WW093"
#define SQLSTATE_CLIENT_TRANSFER_ACCESS_ERROR      "WW094"
#define SQLSTATE_MIRROR_LOG_WITH_DB_MIRROR         "WW095"
#define SQLSTATE_UNABLE_TO_START_ENGINE_MISSING_LICENSE "08WA2"
#define SQLSTATE_OPTION_ON_WATCH_LIST              "WW096"
#define SQLSTATE_DBSPACE_PERMS_NOT_SUPPORTED       "0AW22"
#define SQLSTATE_CORRUPT_ULTRALITE_INDEX           "WI002"
#define SQLSTATE_CORRUPT_ULTRALITE_DATABASE        "WI003"
#define SQLSTATE_UNLOAD_CANNOT_APPEND              "WL012"
#define SQLSTATE_LOAD_TABLE_ERROR                  "WL013"
#define SQLSTATE_UTF16_ENDIAN_MISMATCH             "WC004"
#define SQLSTATE_LOAD_TABLE_ON_MATVIEW_ERROR       "WL014"
#define SQLSTATE_LOAD_TABLE_WITH_IMV               "WL015"
#define SQLSTATE_INVALID_LOAD_TABLE_OPTION         "WL016"
#define SQLSTATE_TRUNCATE_TABLE_WITH_IMV           "55W30"
#define SQLSTATE_LOGIN_POLICY_ALREADY_EXISTS       "WW097"
#define SQLSTATE_LOGIN_POLICY_NOT_FOUND            "WW098"
#define SQLSTATE_LOGIN_POLICY_UPGRADE              "WW099"
#define SQLSTATE_LOGIN_POLICY_IN_USE               "WW100"
#define SQLSTATE_USER_ALREADY_EXISTS               "WW101"
#define SQLSTATE_NO_MATCHING_INDEX                 "42R04"
#define SQLSTATE_CLIENT_TRANSFER_OPEN_ERROR        "WW102"
#define SQLSTATE_CLIENT_TRANSFER_PERMS_ERROR       "WW103"
#define SQLSTATE_UPDATE_ON_EXISTING_DEP_IMV        "55W33"
#ifdef SAINT
#define SQLSTATE_OLIN_AUTHORITIES_UNSUPPORTED      "28W16"
#define SQLSTATE_BAD_PARTITION_BOUND_VALUE         "WW105"
#define SQLSTATE_PARTITION_BOUND_VALUE_CONVERSION  "WW106"
#define SQLSTATE_PARTITION_BOUND_VALUE_ORDER       "WW107"
#define SQLSTATE_UNKNOWN_PARTITION_NAME            "WW113"
#define SQLSTATE_CANNOT_USE_PARTITION_NAME         "WW221"
#define SQLSTATE_PARTITIONS_NOT_ADJACENT           "WW222"
#define SQLSTATE_UNKNOWN_LOGICALFILE_NAME          "WW224"
#define SQLSTATE_TABLE_NOT_PARTITIONED             "WW225"
#define SQLSTATE_TABLE_PARTITIONED                 "WW226"
#define SQLSTATE_WRONG_DBSPACE_TYPE                "WW227"
#define SQLSTATE_CANNOT_MERGE_COLUMN_PARTITION     "WW228"
#define SQLSTATE_CANNOT_CHANGE_PARTITION_KEY       "WW233"
#define SQLSTATE_INVALID_COL_PARTITION_PLACEMENT   "WW235"
#define SQLSTATE_INVALID_COL_PLACEMENT             "WW236"
#define SQLSTATE_UNSUPPORTED_PARTITION_KEY         "WW237"
#define SQLSTATE_IN_DBSPACE_NOT_ALLOWED            "WW238"
#endif
#define SQLSTATE_MERGE_CARDINALITY_VIOLATION       "23509"
#define SQLSTATE_CONNECTION_DISALLOWED_BY_LOGIN_POLICY "28W15"
#define SQLSTATE_EXTERNAL_LIBRARY_IN_USE           "WW108"
#define SQLSTATE_EXTERNAL_LIBRARY_NOT_LOADED       "WW109"
#define SQLSTATE_SYNC_PROFILE_NOT_FOUND            "42W75"
#define SQLSTATE_SYNC_PROFILE_ALREADY_EXISTS       "42W76"
#define SQLSTATE_SYNC_PROFILE_INVALID              "42W77"
#define SQLSTATE_SYNC_PROFILE_UPGRADE              "42W78"
#define SQLSTATE_DUPLICATE_CREATE_DB_OPTION        "42U08"
#define SQLSTATE_TOO_MANY_CURSORS                  "54W12"
#define SQLSTATE_TOO_MANY_COLUMNS_IN_SELECT        "54W13"
#define SQLSTATE_TOO_MANY_COLUMNS_IN_GROUPBY       "54W14"
#define SQLSTATE_TOO_MANY_COLUMNS_IN_PROC_RES      "54W15"
#ifdef SAINT
#define SQLSTATE_IQ_MULTIPLEX_SERVER_NOT_FOUND     "WW110"
#define SQLSTATE_IQ_MPX_INTERNAL_ERROR             "WI111"
#define SQLSTATE_IQ_ONLY_SYNTAX_ERROR              "42W72"
#define SQLSTATE_IQ_DBSPACEFILE_UPDATE_ERROR       "42W7A"
#define SQLSTATE_IQ_MULTIPLEX_ALTERTOSAMECONFIG    "WW117"
#define SQLSTATE_IQ_EVENT_TYPE_ALREADY_EXISTS      "42WD0"
#define SQLSTATE_IQ_EVENT_MULTIPLE_CONDITIONS      "42WD1"
#define SQLSTATE_IQ_EVENT_WRONG_OPERATOR           "42WD2"
#define SQLSTATE_IQ_TRANSACTION_ROLLBACK           "40W09"
#define SQLSTATE_IQ_GTT_ALTER_DROP_NOTALLOWED      "55W35"
#define SQLSTATE_IQ_INVALID_HOSTNAME               "WW121"
#define SQLSTATE_IQ_PARAM_LENGTH_EXCEED_LIMIT      "WW122"
#define SQLSTATE_IQ_MPX_ABS_DBPATH                 "WW123"
#define SQLSTATE_IQ_PARAM_VALUE_NOT_UNIQUE         "WW124"
#define SQLSTATE_IQ_MULTIPLEX_SERVER_LIMIT_EXCEEDED "WW125"
#define SQLSTATE_IQ_INVALID_CONFIG_FAILOVER_COMBINATION "WW126"
#define SQLSTATE_IQ_DROP_MPX_ALLOWED_ONLY_IN_MPX   "WW127"
#define SQLSTATE_IQ_FIRST_SECONDARY_SERVER_CANNOT_BE_EXCLUDED "WW128"
#define SQLSTATE_IQ_CANNOT_CREATE_MPX_COORDINATOR  "WW129"
#define SQLSTATE_MPX_CONFIG_CHANGES_SRV_SHUTDOWN   "WW239"
#define SQLSTATE_EMSG_UDF_RAISED_ERROR             "QFA62"
#endif
#define SQLSTATE_PASSTHROUGH_SQL_SCRIPT_FAILED_W   "01006"
#define SQLSTATE_PASSTHROUGH_SQL_SCRIPT_FAILED_E   "WW112"
#define SQLSTATE_REORG_ALREADY_IN_PROGRESS         "54W51"
#define SQLSTATE_STATEMENT_TIMEOUT                 "57W05"
#define SQLSTATE_HOLD_CURSOR_AFTER_TRUNCATE        "24001"
#define SQLSTATE_ENCRYPT_DATABASE_FAILED           "WW118"
#define SQLSTATE_DECRYPT_DATABASE_FAILED           "WW119"
#define SQLSTATE_MERGE_USER_SPECIFIED_ERROR        "23510"
#define SQLSTATE_HASH_ERROR                        "08W92"
#define SQLSTATE_DUPLICATE_ROW_FOUND_IN_DOWNLOAD   "01W27"
#define SQLSTATE_FEATURE_NOT_LICENSED              "0A002"
#define SQLSTATE_CONNECTION_PROTOCOL_NOT_LICENSED  "0A003"
#define SQLSTATE_PLATFORM_NOT_LICENSED             "0A004"
#if defined ( SAINT )
#define SQLSTATE_IQ_LICENSE_INITIALIZATION_FAILURE "0A005"
#define SQLSTATE_IQ_CORE_LICENSE_CHECKOUT_FAILURE  "0A006"
#endif
#define SQLSTATE_EVENT_NOTIFICATION_QUEUE_FULL     "WE011"
#define SQLSTATE_EVENT_NOTIFICATIONS_LOST          "WE012"
#define SQLSTATE_EVENT_NOTIFICATION_QUEUE_NOT_FOUND_WARN "WE013"
#define SQLSTATE_EVENT_NOTIFICATION_QUEUE_NOT_FOUND "WE014"
#define SQLSTATE_INVALID_EVENT_OBJECT_NAME         "WE015"
#define SQLSTATE_EVENT_OBJECT_ALREADY_EXISTS       "WE016"
#define SQLSTATE_EVENT_NOTIFICATION_QUEUE_TIMEOUT  "WE017"
#define SQLSTATE_EVENT_PARAMETER_NOT_FOUND         "WE018"
#define SQLSTATE_NO_PERMS_FOR_IMV                  "42WD3"
#define SQLSTATE_INCOMPLETE_SYNCHRONIZATION        "0AW23"
#define SQLSTATE_SYNCHRONIZATION_IN_PROGRESS       "0AW24"
#define SQLSTATE_TABLE_HAS_NO_COLUMNS              "0EW00"
#define SQLSTATE_INDEX_HAS_NO_COLUMNS              "0EW01"
#define SQLSTATE_INVALID_DOMAIN                    "54W52"
#define SQLSTATE_CONFIG_IN_USE                     "55W34"
#define SQLSTATE_PARAMETER_CANNOT_BE_NULL          "WW229"
#define SQLSTATE_ULTRALITEJ_OPERATION_NOT_ALLOWED  "WW230"
#define SQLSTATE_ULTRALITEJ_OPERATION_FAILED       "WW231"
#define SQLSTATE_UNDERFLOW                         "WW232"
#define SQLSTATE_ROW_LOCKED                        "42W80"
#define SQLSTATE_DATABASE_UPGRADE_WARNING          "WW234"
#define SQLSTATE_STMT_NOT_ALLOWED_WITH_MIRRORING   "WW120"
#define SQLSTATE_CURSOR_UPDATABILITY_CHANGED       "42WD4"
#define SQLSTATE_CONNECTION_MESSAGE_QUEUE_FULL     "54W16"
#define SQLSTATE_SEQUENCES_NOT_SUPPORTED           "52W52"
#define SQLSTATE_UNIQUE_INDEX_NULLS_NOT_DISTINCT_NOT_SUPPORTED "52W53"
#define SQLSTATE_MIRRORING_OPTIONS_NOT_SUPPORTED   "WW130"
#define SQLSTATE_MIRROR_SERVER_NOT_FOUND           "WW131"
#define SQLSTATE_MIRROR_SERVER_ALREADY_EXISTS      "WW132"
#define SQLSTATE_MIRROR_SERVER_IN_USE              "WW133"
#define SQLSTATE_MIRROR_PARTNERS_ALREADY_DEFINED   "WW134"
#define SQLSTATE_INVALID_MIRROR_PARENT             "WW135"
#define SQLSTATE_MAX_STRING_LENGTH_EXCEEDED        "54W17"
#define SQLSTATE_CANNOT_FORCE_FAILOVER_ON_PREFERRED "WW136"
#define SQLSTATE_SCRIPT_MISSING_DELIMITER          "WW046"
#if defined ( SAINT )
#define SQLSTATE_IQ_LOAD_TABLE_UNSUPPORTED_COLUMN_SPEC "0AW25"
#endif
#define SQLSTATE_TOO_MANY_ARTICLES_DELETED         "42W89"
#define SQLSTATE_SYNC_SCHEMA_UPGRADE               "WW137"
#define SQLSTATE_INVALID_TABLE_TYPE                "WW139"
#define SQLSTATE_SYNC_SCHEMA_IN_PROGRESS           "WW140"
#define SQLSTATE_SUBSCRIPTION_OMITTED              "WW141"
#define SQLSTATE_CONNECTION_HAS_LOCKS              "WW142"
#define SQLSTATE_COLUMN_SUBSET_MISMATCH            "WW138"
#define SQLSTATE_SUBSCRIPTION_NAME_NOT_FOUND       "5RW40"
#define SQLSTATE_TABLE_MUST_SYNCHRONIZE_IN_PUB     "WW143"
#define SQLSTATE_REQUIRES_SYNC_SCHEMA_CHANGE       "5RW41"
#define SQLSTATE_FEATURE_UNKNOWN_OR_INVALID        "WW144"
#define SQLSTATE_FEATURE_NOT_LOCKED                "WW145"
#define SQLSTATE_FEATURE_LOCKED                    "WW146"
#define SQLSTATE_FEATURE_LOCKED_SYNC               "WW147"
#define SQLSTATE_METHOD_ON_NON_EXT                 "42X00"
#define SQLSTATE_METHOD_NOT_FOUND                  "42X01"
#define SQLSTATE_METHOD_NO_OVERLOAD                "42X02"
#define SQLSTATE_METHOD_NO_CONSTRUCTOR             "42X03"
#define SQLSTATE_METHOD_NO_OVERLOAD_N_ARGS         "42X04"
#define SQLSTATE_METHOD_NO_CONSTRUCTOR_N_ARGS      "42X05"
#define SQLSTATE_METHOD_NO_CONSTRUCTOR_OVERLOAD    "42X06"
#define SQLSTATE_SYNC_SCHEMA_CHANGE_DISALLOWS_DML  "5RW42"
#define SQLSTATE_INVALID_CHILD_SERVER_NAME         "WW151"
#define SQLSTATE_PARENT_NOT_CONNECTED              "WW152"
#define SQLSTATE_PARENT_NOT_PRIMARY                "WW153"
#define SQLSTATE_CHILD_SERVER_CREATION_FAILED      "WW154"
#define SQLSTATE_MIRROR_SERVER_TYPE_ALREADY_DEFINED "WW155"
#define SQLSTATE_CANNOT_ASSIGN_AUTO_PARENT         "WW156"
#define SQLSTATE_TREAT_AS_ONLY_EXTENDED            "53020"
#define SQLSTATE_TREAT_AS_DYNAMIC_MISMATCH         "53021"
#define SQLSTATE_SYNCCMD_INTERNAL_ERROR            "5RW43"
#define SQLSTATE_SYNCCMD_SYNCH_FAILED              "5RW44"
#define SQLSTATE_SYNCCMD_START_SERVER_FAIL         "5RW45"
#define SQLSTATE_SYNCCMD_CONNECT_SERVER_FAIL       "5RW46"
#define SQLSTATE_SYNCCMD_TIMEOUT                   "5RW47"
#define SQLSTATE_SYNCCMD_SHUTDOWN_FAIL             "5RW48"
#define SQLSTATE_SYNCCMD_SHUTDOWN_SLOW             "5RW49"
#define SQLSTATE_TOO_MANY_REDIRECTS                "08WA4"
#define SQLSTATE_MIRROR_SERVER_NAME_CONFLICT       "WW159"
#define SQLSTATE_INVALID_DOWNLOAD_VALUE            "0AW26"
#define SQLSTATE_MIRROR_COPY_SERVER_LIMIT_EXCEEDED "WW160"
#define SQLSTATE_UNABLE_TO_STOP_DATABASE           "08WA5"
#define SQLSTATE_MLA_SYNC_FAILED                   "WW161"
#define SQLSTATE_MLA_SYNC_CONNECT_SERVER_FAIL      "WW162"
#define SQLSTATE_MLA_SYNC_SHUTDOWN_FAIL            "WW163"
#define SQLSTATE_MLA_SYNC_START_SERVER_FAIL        "WW164"
#define SQLSTATE_TEMP_TABLE_DEFINITION_CHANGED     "WW165"
#define SQLSTATE_LOAD_TABLE_DATA_FILE_ERROR        "WL017"
#define SQLSTATE_MOBILINK_AUTHENTICATION_FAILED    "28W17"
#define SQLSTATE_UNKNOWN_PROPERTY                  "WU001"
#define SQLSTATE_SLERR_INVALID_RELATE_MATRIX       "2FF04"
#define SQLSTATE_SLERR_DUPLICATE_POINT             "2FF05"
#define SQLSTATE_SLERR_ELEMENT_IS_EMPTY            "2FF06"
#define SQLSTATE_SLERR_MIXED_SRS                   "2FF10"
#define SQLSTATE_SLERR_COMPOUNDCURVE_NOT_CONTIGUOUS "2FF11"
#define SQLSTATE_SLERR_UNKNOWN_UOM                 "2FF14"
#define SQLSTATE_SLERR_TRANSFORM_FAIL              "2FF15"
#define SQLSTATE_SLERR_TRANSFORM_POINT_FAIL        "2FF17"
#define SQLSTATE_SLERR_WKT_PARSE_NEAR              "2FF22"
#define SQLSTATE_SLERR_WKB_PARSE                   "2FF23"
#define SQLSTATE_SLERR_MIXED_DIM                   "2FF25"
#define SQLSTATE_SLERR_SRID_UNKNOWN                "2FF59"
#define SQLSTATE_SLERR_CIRC_NUM_POINTS             "2FF71"
#define SQLSTATE_SLERR_CIRC_COLLINEAR_MIDPOINT     "2FF72"
#define SQLSTATE_SLERR_ST_TO_XXX_FAILN             "2FF16"
#define SQLSTATE_SLERR_NEED_UPGRADE                "2FW02"
#define SQLSTATE_SLERR_NYI                         "2FW03"
#define SQLSTATE_SLERR_WKT_PARSE_INCONSISTENT_ZM   "2FW05"
#define SQLSTATE_SLERR_SERIAL_PARSE                "2FW06"
#define SQLSTATE_SLERR_WKB_PARSE_TYPE              "2FW08"
#define SQLSTATE_SLERR_WKB_PARSE_TYPE_NOT_PERMITTED "2FW09"
#define SQLSTATE_SLERR_WKB_PARSE_UNEXPECTED_EOF    "2FW10"
#define SQLSTATE_SLERR_WKB_PARSE_INCONSISTENT_ZM   "2FW11"
#define SQLSTATE_SLERR_WKB_PARSE_INVALID_BOM       "2FW12"
#define SQLSTATE_SLERR_SHAPE_PARSE                 "2FW13"
#define SQLSTATE_SLERR_SHAPE_PARSE_ATTRIBUTES      "2FW14"
#define SQLSTATE_SLERR_SHAPE_INVALID_FILENAME      "2FW15"
#define SQLSTATE_SLERR_SHAPE_MULTIPATCH            "2FW16"
#define SQLSTATE_SLERR_SRID_CONFLICT_EMBED_PARAM   "2FW19"
#define SQLSTATE_SLERR_SRID_CONFLICT_EMBED_EMBED   "2FW20"
#define SQLSTATE_SLERR_FMT_UNKNOWN                 "2FW21"
#define SQLSTATE_SLERR_FMT_NOT_ALLOWED             "2FW22"
#define SQLSTATE_SLERR_WRONG_FORMAT                "2FW23"
#define SQLSTATE_SLERR_INVALID_FORMAT_SPECIFICATION "2FW24"
#define SQLSTATE_SLERR_INVALID_FORMAT_SPECIFICATION_OPTION "2FW25"
#define SQLSTATE_SLERR_INVALID_FORMAT_SPECIFICATION_OPTION_VALUE "2FW26"
#define SQLSTATE_SLERR_UNKOWNN_FORMAT              "2FW27"
#define SQLSTATE_SLERR_ROUND_EARTH_UNSUPPORTED     "2FW28"
#define SQLSTATE_SLERR_ROUND_EARTH_UNSUPPORTED_DIS "2FW29"
#define SQLSTATE_SLERR_CONFIG_FILE_ERR             "2FW31"
#define SQLSTATE_SLERR_CONFIG_NO_SUBFILE           "2FW32"
#define SQLSTATE_SLERR_COMPARISON_PREDICATE        "2FW33"
#define SQLSTATE_SLERR_SRS_PARSE_ERROR             "2FW34"
#define SQLSTATE_SLERR_INVALID_TRANSFORM_DEF       "2FW35"
#define SQLSTATE_SLERR_TRANSFORM_DEF_TOO_LONG      "2FW36"
#define SQLSTATE_SLERR_NO_XFORM_DEF                "2FW37"
#define SQLSTATE_SLERR_NO_SRC_XFORM_DEF            "2FW38"
#define SQLSTATE_SLERR_UOM_NOT_LINEAR              "2FW39"
#define SQLSTATE_SLERR_UOM_NOT_ANGULAR             "2FW40"
#define SQLSTATE_SLERR_INVALID_POLY_ORD            "2FW41"
#define SQLSTATE_SLERR_INVALID_POLY_NO_EXT         "2FW42"
#define SQLSTATE_SLERR_INVALID_POLY_NESTING        "2FW43"
#define SQLSTATE_SLERR_INVALID_POLY_MULT_EXT       "2FW44"
#define SQLSTATE_SLERR_UPDDEL_NO_PK                "2FW45"
#define SQLSTATE_SLERR_CREATE_INDEX_UNIQUE         "2FW46"
#define SQLSTATE_SLERR_CREATE_INDEX_NOSRID         "2FW47"
#define SQLSTATE_SLERR_DDL_UOM_NOFACT              "2FW48"
#define SQLSTATE_SLERR_DDL_SRS_AXISORDER           "2FW49"
#define SQLSTATE_SLERR_DDL_SRS_COORDNAME           "2FW50"
#define SQLSTATE_SLERR_DDL_NO_UOM                  "2FW51"
#define SQLSTATE_SLERR_DDL_NO_SRS                  "2FW52"
#define SQLSTATE_SLERR_DDL_UOM_EXISTS              "2FW53"
#define SQLSTATE_SLERR_DDL_SRS_EXISTS              "2FW54"
#define SQLSTATE_SLERR_DDL_SRS_NOSRID              "2FW55"
#define SQLSTATE_SLERR_DDL_SRS_BADWKT              "2FW56"
#define SQLSTATE_SLERR_DDL_SRS_BAD_SRS_TYPE        "2FW57"
#define SQLSTATE_SLERR_DDL_SRS_NOELLIPSOID         "2FW58"
#define SQLSTATE_SLERR_DDL_SRS_ELLIPSOID           "2FW59"
#define SQLSTATE_SLERR_DDL_SRS_MUSTBOUND           "2FW60"
#define SQLSTATE_SLERR_DDL_SRS_AXISORD             "2FW61"
#define SQLSTATE_SLERR_DDL_SRS_POLYFORMAT          "2FW62"
#define SQLSTATE_SLERR_DDL_SRS_STGFORMAT           "2FW63"
#define SQLSTATE_SLERR_DDL_SRS_INUSE               "2FW64"
#define SQLSTATE_SLERR_DDL_SRS_RESERVED            "2FW65"
#define SQLSTATE_SLERR_DDL_UOM_RESERVED            "2FW66"
#define SQLSTATE_SLERR_SRS_INUSE_TAB               "2FW67"
#define SQLSTATE_SLERR_SRS_INUSE_PROC              "2FW68"
#define SQLSTATE_SLERR_SRS_INUSE_TYPE              "2FW69"
#define SQLSTATE_SLERR_NOT_GEOGRAPHIC              "2FW70"
#define SQLSTATE_SLERR_SPATIAL_IN_BUILTIN          "2FW71"
#define SQLSTATE_SLERR_NOT_UNION_COMPAT            "2FW72"
#define SQLSTATE_SLERR_INTERNAL_ERROR              "2FW73"
#define SQLSTATE_SLERR_NEARLY_ANTIPODAL            "2FW77"
#define SQLSTATE_SLERR_LINESTRING_MIN_POINTS       "2FW78"
#define SQLSTATE_SLERR_OBJECT_OUT_OF_SRS_BOUNDS    "2FW79"
#define SQLSTATE_SLERR_INVALID_POLY_RING_CLOSE     "2FW80"
#define SQLSTATE_SLERR_INVALID_POLY_EMPTY_RING     "2FW81"
#define SQLSTATE_SLERR_INVALID_POLY_NON_RING       "2FW82"
#define SQLSTATE_SLERR_INVALID_POLY_RE_SIZE        "2FW83"
#define SQLSTATE_SLWARN_INVALID_POSITION           "01F01"
#define SQLSTATE_SLWARN_POLYGON_RING_REORIENTED    "01FW1"
#define SQLSTATE_SLWARN_CIRCULARSTRING_3POINT      "01FW2"
#define SQLSTATE_SLERR_CIRCULAR_METHOD             "2FW84"
#define SQLSTATE_SLERR_CIRCULAR_SRS                "2FW85"
#define SQLSTATE_SLERR_INVALID_GRID_SIZE           "2FW86"
#define SQLSTATE_SLERR_INVALID_TOLERANCE           "2FW87"
#define SQLSTATE_SLERR_INVALID_BOUNDS              "2FW88"
#define SQLSTATE_SLERR_INVALID_MULTISURF_I         "2FW89"
#define SQLSTATE_SLERR_GEOM_COLL_INTERSECT         "2FW90"
#define SQLSTATE_SLERR_CPU_NEED_SSE                "2FW91"
#define SQLSTATE_SLERR_GEOM_ORDER_BY               "2FW92"
#define SQLSTATE_COPY_SERVER_NEEDS_PARENT          "42WE6"
#define SQLSTATE_NO_TABLES_TO_SYNCHRONIZE          "01W28"
#define SQLSTATE_UNKNOWN_COLLATION                 "WC018"
#define SQLSTATE_SELECT_DML_OUTER_REFERENCE        "42U09"
#endif
